

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.acquisition;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="detectorsettings_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="detectorsettings_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="detectorsettings_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="detectorsettings_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="detectorsettings_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="detectorsettings_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="detectorsettings_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="detectorsettings_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
        "id IN (SELECT detectorsettings.id FROM detectorsettings*, detector*, image* WHERE " +
        "detectorsettings.detector = detector.id AND detector.instrument = image.instrument AND image.id IN (:images)))")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "detectorsettings", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_detectorsettings",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_detectorsettings"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class DetectorSettings
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "detectorsettings_owner_filter";
    public final static String GROUP_FILTER = "detectorsettings_group_filter";
    public final static String EVENT_FILTER = "detectorsettings_event_filter";
    public final static String PERMS_FILTER = "detectorsettings_perms_filter";

    public DetectorSettings () {
        this(null, true);
    }

    protected DetectorSettings (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public DetectorSettings (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public DetectorSettings(
ome.model.acquisition.Detector _detector    ) {
        this(null, true);
        setDetector(_detector);
    }

    public final static String ID = "ome.model.acquisition.DetectorSettings_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_detectorsettings") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.acquisition.DetectorSettings_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected ome.model.units.ElectricPotential voltage = null;

 
   /**
    * Enum-mapped unit-based field ome.model.acquisition.DetectorSettings.voltage (ome.model.units.ElectricPotential)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="voltage") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="voltageUnit") )
    } )
    public ome.model.units.ElectricPotential getVoltage() {
        if (! _loaded ) errorIfUnloaded();
        return this.voltage;
    }

    public void setVoltage(ome.model.units.ElectricPotential voltage) {
        if (! _loaded ) errorIfUnloaded();
        this.voltage = voltage;
    }

    protected java.lang.Double gain = null;

   /**
    * Simple field ome.model.acquisition.DetectorSettings.gain (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="gain", updatable=true)
    public java.lang.Double getGain() {
        if (! _loaded ) errorIfUnloaded();
        return this.gain;
    }

    public void setGain(java.lang.Double gain) {
        if (! _loaded ) errorIfUnloaded();
        this.gain = (java.lang.Double) gain;
    }
    protected java.lang.Double offsetValue = null;

   /**
    * Simple field ome.model.acquisition.DetectorSettings.offsetValue (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="offsetValue", updatable=true)
    public java.lang.Double getOffsetValue() {
        if (! _loaded ) errorIfUnloaded();
        return this.offsetValue;
    }

    public void setOffsetValue(java.lang.Double offsetValue) {
        if (! _loaded ) errorIfUnloaded();
        this.offsetValue = (java.lang.Double) offsetValue;
    }
    protected ome.model.units.Frequency readOutRate = null;

 
   /**
    * Enum-mapped unit-based field ome.model.acquisition.DetectorSettings.readOutRate (ome.model.units.Frequency)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="readOutRate") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="readOutRateUnit") )
    } )
    public ome.model.units.Frequency getReadOutRate() {
        if (! _loaded ) errorIfUnloaded();
        return this.readOutRate;
    }

    public void setReadOutRate(ome.model.units.Frequency readOutRate) {
        if (! _loaded ) errorIfUnloaded();
        this.readOutRate = readOutRate;
    }

    protected ome.model.enums.Binning binning = null;

   /**
    * Many-to-one field ome.model.acquisition.DetectorSettings.binning (ome.model.enums.Binning)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.Binning.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="binning", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKdetectorsettings_binning_binning")
    public ome.model.enums.Binning getBinning() {
        if (! _loaded ) errorIfUnloaded();
        return this.binning;
    }

    public void setBinning(ome.model.enums.Binning binning) {
        if (! _loaded ) errorIfUnloaded();
        this.binning = binning;
    }
    protected java.lang.Integer integration = null;

   /**
    * Simple field ome.model.acquisition.DetectorSettings.integration (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="positive_int", nullable=true, unique=false, name="integration", updatable=true)
    public java.lang.Integer getIntegration() {
        if (! _loaded ) errorIfUnloaded();
        return this.integration;
    }

    public void setIntegration(java.lang.Integer integration) {
        if (! _loaded ) errorIfUnloaded();
        if (integration != null && integration <= 0) {
            throw new IllegalArgumentException("values of DetectorSettings.integration must be strictly positive");
        }
        this.integration = (java.lang.Integer) integration;
    }
    protected java.lang.Double zoom = null;

   /**
    * Simple field ome.model.acquisition.DetectorSettings.zoom (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="zoom", updatable=true)
    public java.lang.Double getZoom() {
        if (! _loaded ) errorIfUnloaded();
        return this.zoom;
    }

    public void setZoom(java.lang.Double zoom) {
        if (! _loaded ) errorIfUnloaded();
        this.zoom = (java.lang.Double) zoom;
    }
    protected ome.model.acquisition.Detector detector = null;

   /**
    * Many-to-one field ome.model.acquisition.DetectorSettings.detector (ome.model.acquisition.Detector)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.Detector.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="detector", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKdetectorsettings_detector_detector")
    public ome.model.acquisition.Detector getDetector() {
        if (! _loaded ) errorIfUnloaded();
        return this.detector;
    }

    public void setDetector(ome.model.acquisition.Detector detector) {
        if (! _loaded ) errorIfUnloaded();
        this.detector = detector;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.acquisition.DetectorSettings newInstance()
    {
        return new ome.model.acquisition.DetectorSettings();
    }

    public ome.model.acquisition.DetectorSettings proxy() {
        return new ome.model.acquisition.DetectorSettings(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.voltage = (ome.model.units.ElectricPotential) __filter.filter(VOLTAGE, this.voltage );
            this.gain = (java.lang.Double) __filter.filter(GAIN, this.gain );
            this.offsetValue = (java.lang.Double) __filter.filter(OFFSETVALUE, this.offsetValue );
            this.readOutRate = (ome.model.units.Frequency) __filter.filter(READOUTRATE, this.readOutRate );
            this.binning = (ome.model.enums.Binning) __filter.filter(BINNING, this.binning );
            this.integration = (java.lang.Integer) __filter.filter(INTEGRATION, this.integration );
            this.zoom = (java.lang.Double) __filter.filter(ZOOM, this.zoom );
            this.detector = (ome.model.acquisition.Detector) __filter.filter(DETECTOR, this.detector );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.acquisition.DetectorSettings.FIELDS;
    }

    public final static String VOLTAGE = "ome.model.acquisition.DetectorSettings_voltage";
    public final static String GAIN = "ome.model.acquisition.DetectorSettings_gain";
    public final static String OFFSETVALUE = "ome.model.acquisition.DetectorSettings_offsetValue";
    public final static String READOUTRATE = "ome.model.acquisition.DetectorSettings_readOutRate";
    public final static String BINNING = "ome.model.acquisition.DetectorSettings_binning";
    public final static String INTEGRATION = "ome.model.acquisition.DetectorSettings_integration";
    public final static String ZOOM = "ome.model.acquisition.DetectorSettings_zoom";
    public final static String DETECTOR = "ome.model.acquisition.DetectorSettings_detector";
    public final static String DETAILS = "ome.model.acquisition.DetectorSettings_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(VOLTAGE);
       raw.add(GAIN);
       raw.add(OFFSETVALUE);
       raw.add(READOUTRATE);
       raw.add(BINNING);
       raw.add(INTEGRATION);
       raw.add(ZOOM);
       raw.add(DETECTOR);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(VOLTAGE)) {
            return getVoltage();
        } else if (field.equals(GAIN)) {
            return getGain();
        } else if (field.equals(OFFSETVALUE)) {
            return getOffsetValue();
        } else if (field.equals(READOUTRATE)) {
            return getReadOutRate();
        } else if (field.equals(BINNING)) {
            return getBinning();
        } else if (field.equals(INTEGRATION)) {
            return getIntegration();
        } else if (field.equals(ZOOM)) {
            return getZoom();
        } else if (field.equals(DETECTOR)) {
            return getDetector();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(VOLTAGE)) {
            setVoltage((ome.model.units.ElectricPotential)value);
        } else if (field.equals(GAIN)) {
            setGain((java.lang.Double)value);
        } else if (field.equals(OFFSETVALUE)) {
            setOffsetValue((java.lang.Double)value);
        } else if (field.equals(READOUTRATE)) {
            setReadOutRate((ome.model.units.Frequency)value);
        } else if (field.equals(BINNING)) {
            setBinning((ome.model.enums.Binning)value);
        } else if (field.equals(INTEGRATION)) {
            setIntegration((java.lang.Integer)value);
        } else if (field.equals(ZOOM)) {
            setZoom((java.lang.Double)value);
        } else if (field.equals(DETECTOR)) {
            setDetector((ome.model.acquisition.Detector)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.voltage = null;
        this.gain = null;
        this.offsetValue = null;
        this.readOutRate = null;
        this.binning = null;
        this.integration = null;
        this.zoom = null;
        this.detector = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKdetectorsettings_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKdetectorsettings_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKdetectorsettings_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKdetectorsettings_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKdetectorsettings_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
