

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.acquisition;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="filter_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="filter_owner_filter_EXCITATIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_group_filter_EXCITATIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_event_filter_EXCITATIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_perms_filter_EXCITATIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="filter_owner_filter_EMISSIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_group_filter_EMISSIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_event_filter_EMISSIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_perms_filter_EMISSIONFILTERLINK",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="filter_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="filter_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="filter_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="filter_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="filter_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="filter_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
        "id IN (SELECT filter.id FROM filter*, image* WHERE " +
        "filter.instrument = image.instrument AND image.id IN (:images)))")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "filter", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_filter",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_filter"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Filter
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "filter_owner_filter";
    public final static String GROUP_FILTER = "filter_group_filter";
    public final static String EVENT_FILTER = "filter_event_filter";
    public final static String PERMS_FILTER = "filter_perms_filter";

    public Filter () {
        this(null, true);
    }

    protected Filter (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Filter (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Filter(
ome.model.acquisition.Instrument _instrument    ) {
        this(null, true);
        setInstrument(_instrument);
    }

    public final static String ID = "ome.model.acquisition.Filter_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_filter") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.acquisition.Filter_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String manufacturer = null;

   /**
    * Simple field ome.model.acquisition.Filter.manufacturer (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="manufacturer", updatable=true)
    public java.lang.String getManufacturer() {
        if (! _loaded ) errorIfUnloaded();
        return this.manufacturer;
    }

    public void setManufacturer(java.lang.String manufacturer) {
        if (! _loaded ) errorIfUnloaded();
        this.manufacturer = (java.lang.String) manufacturer;
    }
    protected java.lang.String model = null;

   /**
    * Simple field ome.model.acquisition.Filter.model (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="model", updatable=true)
    public java.lang.String getModel() {
        if (! _loaded ) errorIfUnloaded();
        return this.model;
    }

    public void setModel(java.lang.String model) {
        if (! _loaded ) errorIfUnloaded();
        this.model = (java.lang.String) model;
    }
    protected java.lang.String lotNumber = null;

   /**
    * Simple field ome.model.acquisition.Filter.lotNumber (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="lotNumber", updatable=true)
    public java.lang.String getLotNumber() {
        if (! _loaded ) errorIfUnloaded();
        return this.lotNumber;
    }

    public void setLotNumber(java.lang.String lotNumber) {
        if (! _loaded ) errorIfUnloaded();
        this.lotNumber = (java.lang.String) lotNumber;
    }
    protected java.lang.String serialNumber = null;

   /**
    * Simple field ome.model.acquisition.Filter.serialNumber (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="serialNumber", updatable=true)
    public java.lang.String getSerialNumber() {
        if (! _loaded ) errorIfUnloaded();
        return this.serialNumber;
    }

    public void setSerialNumber(java.lang.String serialNumber) {
        if (! _loaded ) errorIfUnloaded();
        this.serialNumber = (java.lang.String) serialNumber;
    }
    protected java.lang.String filterWheel = null;

   /**
    * Simple field ome.model.acquisition.Filter.filterWheel (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="filterWheel", updatable=true)
    public java.lang.String getFilterWheel() {
        if (! _loaded ) errorIfUnloaded();
        return this.filterWheel;
    }

    public void setFilterWheel(java.lang.String filterWheel) {
        if (! _loaded ) errorIfUnloaded();
        this.filterWheel = (java.lang.String) filterWheel;
    }
    protected ome.model.enums.FilterType type = null;

   /**
    * Many-to-one field ome.model.acquisition.Filter.type (ome.model.enums.FilterType)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.FilterType.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="type", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKfilter_type_filtertype")
    public ome.model.enums.FilterType getType() {
        if (! _loaded ) errorIfUnloaded();
        return this.type;
    }

    public void setType(ome.model.enums.FilterType type) {
        if (! _loaded ) errorIfUnloaded();
        this.type = type;
    }
    protected ome.model.acquisition.TransmittanceRange transmittanceRange = null;

   /**
    * Many-to-one field ome.model.acquisition.Filter.transmittanceRange (ome.model.acquisition.TransmittanceRange)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.TransmittanceRange.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="transmittanceRange", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKfilter_transmittanceRange_transmittancerange")
    public ome.model.acquisition.TransmittanceRange getTransmittanceRange() {
        if (! _loaded ) errorIfUnloaded();
        return this.transmittanceRange;
    }

    public void setTransmittanceRange(ome.model.acquisition.TransmittanceRange transmittanceRange) {
        if (! _loaded ) errorIfUnloaded();
        this.transmittanceRange = transmittanceRange;
    }
    protected ome.model.acquisition.Instrument instrument = null;

   /**
    * Many-to-one field ome.model.acquisition.Filter.instrument (ome.model.acquisition.Instrument)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.Instrument.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="instrument", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKfilter_instrument_instrument")
    public ome.model.acquisition.Instrument getInstrument() {
        if (! _loaded ) errorIfUnloaded();
        return this.instrument;
    }

    public void setInstrument(ome.model.acquisition.Instrument instrument) {
        if (! _loaded ) errorIfUnloaded();
        this.instrument = instrument;
    }
    protected java.util.Set<ome.model.acquisition.FilterSetExcitationFilterLink> excitationFilterLink = new java.util.HashSet<ome.model.acquisition.FilterSetExcitationFilterLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_EXCITATIONFILTERLINK = "filter_owner_filter_EXCITATIONFILTERLINK";
    public final static String GROUP_FILTER_EXCITATIONFILTERLINK = "filter_group_filter_EXCITATIONFILTERLINK";
    public final static String EVENT_FILTER_EXCITATIONFILTERLINK = "filter_event_filter_EXCITATIONFILTERLINK";
    public final static String PERMS_FILTER_EXCITATIONFILTERLINK = "filter_perms_filter_EXCITATIONFILTERLINK";

   /**
    * returns excitationFilterLink . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.acquisition.Filter.excitationFilterLink (ome.model.acquisition.FilterSetExcitationFilterLink)
    */
    @javax.persistence.OneToMany(mappedBy="child", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
            "id IN (SELECT link.id FROM filtersetexcitationfilterlink AS link*, filter*, image* WHERE " +
            "link.child = filter.id AND filter.instrument = image.instrument AND image.id IN (:images)))"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_EXCITATIONFILTERLINK, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_EXCITATIONFILTERLINK, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_EXCITATIONFILTERLINK, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_EXCITATIONFILTERLINK, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.acquisition.FilterSetExcitationFilterLink> getExcitationFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        return this.excitationFilterLink;
    }

    /**
     * setter for excitationFilterLink should be avoided. Does not fulfill normal semantics.
     */
    protected void setExcitationFilterLink(java.util.Set<ome.model.acquisition.FilterSetExcitationFilterLink> excitationFilterLink) {
        if (! _loaded ) errorIfUnloaded();
        this.excitationFilterLink = excitationFilterLink;
    }
    /**
     * returns the size of excitationFilterLink. If less than zero, the Set was null.
     */
    public int sizeOfExcitationFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        return this.excitationFilterLink == null ? -1 : this.excitationFilterLink.size();
    }

    /**
     * should be used rather than accessing the excitationFilterLink set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfExcitationFilterLink()} is less than zero.
     */
    public java.util.Iterator<ome.model.acquisition.FilterSetExcitationFilterLink> iterateExcitationFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        if ( getExcitationFilterLink() == null ) {
            return new ome.util.EmptyIterator<ome.model.acquisition.FilterSetExcitationFilterLink>();
        }
        return getExcitationFilterLink().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.acquisition.FilterSetExcitationFilterLink> unmodifiableExcitationFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        if ( getExcitationFilterLink() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getExcitationFilterLink() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.acquisition.FilterSetExcitationFilterLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateExcitationFilterLink} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectExcitationFilterLink(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.acquisition.FilterSetExcitationFilterLink> it = iterateExcitationFilterLink();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setExcitationFilterLink . Makes the necessary
     * call on ome.model.acquisition.FilterSetExcitationFilterLink as well.
     */
    public void addFilterSetExcitationFilterLink(ome.model.acquisition.FilterSetExcitationFilterLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setChild ( this );
         }
    }

    /**
     * use like addFilterSetExcitationFilterLink.
     */
    public void addFilterSetExcitationFilterLinkSet(java.util.Collection<ome.model.acquisition.FilterSetExcitationFilterLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
           throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().addAll( targets );
        java.util.Iterator<ome.model.acquisition.FilterSetExcitationFilterLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.FilterSetExcitationFilterLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setChild ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.acquisition.FilterSetExcitationFilterLink
     */
    public void removeFilterSetExcitationFilterLink(ome.model.acquisition.FilterSetExcitationFilterLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().remove( target );
            target.setChild ( null );
    }

    /**
     * use like removeFilterSetExcitationFilterLink
     */
    public void removeFilterSetExcitationFilterLinkSet(java.util.Collection<ome.model.acquisition.FilterSetExcitationFilterLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getExcitationFilterLink() == null) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().removeAll( targets );
        java.util.Iterator<ome.model.acquisition.FilterSetExcitationFilterLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.FilterSetExcitationFilterLink target = it.next();
                target.setChild ( null );
        }
    }




    /**
     * Adds a ome.model.acquisition.FilterSetExcitationFilterLink to excitationFilterLink . This entails changing our excitationFilterLink Set,
     * creating a new ome.model.acquisition.FilterSetExcitationFilterLink and calling linkExcitationFilter on the ome.model.acquisition.FilterSet.
     */
    public ome.model.acquisition.FilterSetExcitationFilterLink linkExcitationFilter (ome.model.acquisition.FilterSet addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.acquisition.FilterSetExcitationFilterLink link = new ome.model.acquisition.FilterSetExcitationFilterLink();
        link.link( addition, this );

        // Add it to us and possibly the other side.
        addFilterSetExcitationFilterLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.acquisition.FilterSetExcitationFilterLink to excitationFilterLink, allowing for recursion -- whether
     * or not addFilterSetExcitationFilterLink will be called on the addition <b>if it is loaded</b>
     */
    public void addFilterSetExcitationFilterLink (ome.model.acquisition.FilterSetExcitationFilterLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getExcitationFilterLink() == null ) {
            throwNullCollectionException("ExcitationFilterLink");
        }
        getExcitationFilterLink().add( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().addFilterSetExcitationFilterLink( link, false );
        }
    }

    /**
     * provides an iterator over the child values of the excitationFilterLink. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedExcitationFilterList()} instead.
     */
     public java.util.Iterator<ome.model.acquisition.FilterSet> linkedExcitationFilterIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getExcitationFilterLink() == null ) {
            return new ome.util.EmptyIterator<ome.model.acquisition.FilterSet>();
        }

        final java.util.Iterator<ome.model.acquisition.FilterSetExcitationFilterLink> it = getExcitationFilterLink().iterator();
        return new java.util.Iterator<ome.model.acquisition.FilterSet>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.acquisition.FilterSet next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "excitationFilterLink is null; no elements." );
                }
                ome.model.acquisition.FilterSetExcitationFilterLink link = (ome.model.acquisition.FilterSetExcitationFilterLink) it.next();
                return link.parent();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.acquisition.FilterSetExcitationFilterLink which have the argument as their parent.
     */
    public java.util.Set<ome.model.acquisition.FilterSetExcitationFilterLink> findFilterSetExcitationFilterLink( ome.model.acquisition.FilterSet target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.acquisition.FilterSetExcitationFilterLink> it = iterateExcitationFilterLink();
        final java.util.Set<ome.model.acquisition.FilterSetExcitationFilterLink> result = new java.util.HashSet<ome.model.acquisition.FilterSetExcitationFilterLink>();
        while ( it.hasNext() ) {
            ome.model.acquisition.FilterSetExcitationFilterLink link = it.next();
            if ( link.parent() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedExcitationFilterIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.acquisition.FilterSet> linkedExcitationFilterList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.acquisition.FilterSet> it = linkedExcitationFilterIterator();
        java.util.List<ome.model.acquisition.FilterSet> list = new java.util.ArrayList<ome.model.acquisition.FilterSet>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.acquisition.FilterSet while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedExcitationFilter(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.acquisition.FilterSet> it = linkedExcitationFilterIterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.FilterSet obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.acquisition.FilterSet instances from this instance.
     */
    public void unlinkExcitationFilter (ome.model.acquisition.FilterSet removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.acquisition.FilterSetExcitationFilterLink> toRemove = findFilterSetExcitationFilterLink( removal );
        java.util.Iterator<ome.model.acquisition.FilterSetExcitationFilterLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeFilterSetExcitationFilterLink( it.next(), true );
        }
    }

    /**
     * removes the given FilterSetExcitationFilterLink from excitationFilterLink, allowing for recursion -- whether
     * or not the removal will call unlinkFilter again <b>if loaded</b>.
     */
    public void removeFilterSetExcitationFilterLink (ome.model.acquisition.FilterSetExcitationFilterLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getExcitationFilterLink() == null ) {
            throwNullCollectionException("ExcitationFilterLink");
        }

        getExcitationFilterLink().remove( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().removeFilterSetExcitationFilterLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearExcitationFilterLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.acquisition.FilterSetExcitationFilterLink> list = new java.util.ArrayList<ome.model.acquisition.FilterSetExcitationFilterLink>( getExcitationFilterLink() );
        for (ome.model.acquisition.FilterSetExcitationFilterLink link : list) {
            removeFilterSetExcitationFilterLink( link, true );
        }
    }

    private java.util.Map<Long, Long> excitationFilterLinkCountPerOwner = null;

    protected void setExcitationFilterLinkCountPerOwner(java.util.Map<Long, Long> map) {
        this.excitationFilterLinkCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Filter_excitationFilterLink_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.acquisition.FilterSetExcitationFilterLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Filter_excitationFilterLink") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Filter_excitationFilterLink_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Filter_id"))
    public java.util.Map<Long, Long> getExcitationFilterLinkCountPerOwner() {
        return this.excitationFilterLinkCountPerOwner;
    }

    protected java.util.Set<ome.model.acquisition.FilterSetEmissionFilterLink> emissionFilterLink = new java.util.HashSet<ome.model.acquisition.FilterSetEmissionFilterLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_EMISSIONFILTERLINK = "filter_owner_filter_EMISSIONFILTERLINK";
    public final static String GROUP_FILTER_EMISSIONFILTERLINK = "filter_group_filter_EMISSIONFILTERLINK";
    public final static String EVENT_FILTER_EMISSIONFILTERLINK = "filter_event_filter_EMISSIONFILTERLINK";
    public final static String PERMS_FILTER_EMISSIONFILTERLINK = "filter_perms_filter_EMISSIONFILTERLINK";

   /**
    * returns emissionFilterLink . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.acquisition.Filter.emissionFilterLink (ome.model.acquisition.FilterSetEmissionFilterLink)
    */
    @javax.persistence.OneToMany(mappedBy="child", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
            "id IN (SELECT link.id FROM filtersetemissionfilterlink AS link*, filter*, image* WHERE " +
            "link.child = filter.id AND filter.instrument = image.instrument AND image.id IN (:images)))"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_EMISSIONFILTERLINK, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_EMISSIONFILTERLINK, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_EMISSIONFILTERLINK, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_EMISSIONFILTERLINK, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.acquisition.FilterSetEmissionFilterLink> getEmissionFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        return this.emissionFilterLink;
    }

    /**
     * setter for emissionFilterLink should be avoided. Does not fulfill normal semantics.
     */
    protected void setEmissionFilterLink(java.util.Set<ome.model.acquisition.FilterSetEmissionFilterLink> emissionFilterLink) {
        if (! _loaded ) errorIfUnloaded();
        this.emissionFilterLink = emissionFilterLink;
    }
    /**
     * returns the size of emissionFilterLink. If less than zero, the Set was null.
     */
    public int sizeOfEmissionFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        return this.emissionFilterLink == null ? -1 : this.emissionFilterLink.size();
    }

    /**
     * should be used rather than accessing the emissionFilterLink set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfEmissionFilterLink()} is less than zero.
     */
    public java.util.Iterator<ome.model.acquisition.FilterSetEmissionFilterLink> iterateEmissionFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        if ( getEmissionFilterLink() == null ) {
            return new ome.util.EmptyIterator<ome.model.acquisition.FilterSetEmissionFilterLink>();
        }
        return getEmissionFilterLink().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.acquisition.FilterSetEmissionFilterLink> unmodifiableEmissionFilterLink() {
        if (! _loaded ) errorIfUnloaded();
        if ( getEmissionFilterLink() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getEmissionFilterLink() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.acquisition.FilterSetEmissionFilterLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateEmissionFilterLink} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectEmissionFilterLink(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.acquisition.FilterSetEmissionFilterLink> it = iterateEmissionFilterLink();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setEmissionFilterLink . Makes the necessary
     * call on ome.model.acquisition.FilterSetEmissionFilterLink as well.
     */
    public void addFilterSetEmissionFilterLink(ome.model.acquisition.FilterSetEmissionFilterLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getEmissionFilterLink() == null) {
            throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setChild ( this );
         }
    }

    /**
     * use like addFilterSetEmissionFilterLink.
     */
    public void addFilterSetEmissionFilterLinkSet(java.util.Collection<ome.model.acquisition.FilterSetEmissionFilterLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getEmissionFilterLink() == null) {
           throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().addAll( targets );
        java.util.Iterator<ome.model.acquisition.FilterSetEmissionFilterLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.FilterSetEmissionFilterLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setChild ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.acquisition.FilterSetEmissionFilterLink
     */
    public void removeFilterSetEmissionFilterLink(ome.model.acquisition.FilterSetEmissionFilterLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getEmissionFilterLink() == null) {
            throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().remove( target );
            target.setChild ( null );
    }

    /**
     * use like removeFilterSetEmissionFilterLink
     */
    public void removeFilterSetEmissionFilterLinkSet(java.util.Collection<ome.model.acquisition.FilterSetEmissionFilterLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getEmissionFilterLink() == null) {
            throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().removeAll( targets );
        java.util.Iterator<ome.model.acquisition.FilterSetEmissionFilterLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.FilterSetEmissionFilterLink target = it.next();
                target.setChild ( null );
        }
    }




    /**
     * Adds a ome.model.acquisition.FilterSetEmissionFilterLink to emissionFilterLink . This entails changing our emissionFilterLink Set,
     * creating a new ome.model.acquisition.FilterSetEmissionFilterLink and calling linkEmissionFilter on the ome.model.acquisition.FilterSet.
     */
    public ome.model.acquisition.FilterSetEmissionFilterLink linkEmissionFilter (ome.model.acquisition.FilterSet addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.acquisition.FilterSetEmissionFilterLink link = new ome.model.acquisition.FilterSetEmissionFilterLink();
        link.link( addition, this );

        // Add it to us and possibly the other side.
        addFilterSetEmissionFilterLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.acquisition.FilterSetEmissionFilterLink to emissionFilterLink, allowing for recursion -- whether
     * or not addFilterSetEmissionFilterLink will be called on the addition <b>if it is loaded</b>
     */
    public void addFilterSetEmissionFilterLink (ome.model.acquisition.FilterSetEmissionFilterLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getEmissionFilterLink() == null ) {
            throwNullCollectionException("EmissionFilterLink");
        }
        getEmissionFilterLink().add( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().addFilterSetEmissionFilterLink( link, false );
        }
    }

    /**
     * provides an iterator over the child values of the emissionFilterLink. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedEmissionFilterList()} instead.
     */
     public java.util.Iterator<ome.model.acquisition.FilterSet> linkedEmissionFilterIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getEmissionFilterLink() == null ) {
            return new ome.util.EmptyIterator<ome.model.acquisition.FilterSet>();
        }

        final java.util.Iterator<ome.model.acquisition.FilterSetEmissionFilterLink> it = getEmissionFilterLink().iterator();
        return new java.util.Iterator<ome.model.acquisition.FilterSet>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.acquisition.FilterSet next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "emissionFilterLink is null; no elements." );
                }
                ome.model.acquisition.FilterSetEmissionFilterLink link = (ome.model.acquisition.FilterSetEmissionFilterLink) it.next();
                return link.parent();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.acquisition.FilterSetEmissionFilterLink which have the argument as their parent.
     */
    public java.util.Set<ome.model.acquisition.FilterSetEmissionFilterLink> findFilterSetEmissionFilterLink( ome.model.acquisition.FilterSet target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.acquisition.FilterSetEmissionFilterLink> it = iterateEmissionFilterLink();
        final java.util.Set<ome.model.acquisition.FilterSetEmissionFilterLink> result = new java.util.HashSet<ome.model.acquisition.FilterSetEmissionFilterLink>();
        while ( it.hasNext() ) {
            ome.model.acquisition.FilterSetEmissionFilterLink link = it.next();
            if ( link.parent() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedEmissionFilterIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.acquisition.FilterSet> linkedEmissionFilterList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.acquisition.FilterSet> it = linkedEmissionFilterIterator();
        java.util.List<ome.model.acquisition.FilterSet> list = new java.util.ArrayList<ome.model.acquisition.FilterSet>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.acquisition.FilterSet while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedEmissionFilter(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.acquisition.FilterSet> it = linkedEmissionFilterIterator();
        while ( it.hasNext() ) {
            ome.model.acquisition.FilterSet obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.acquisition.FilterSet instances from this instance.
     */
    public void unlinkEmissionFilter (ome.model.acquisition.FilterSet removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.acquisition.FilterSetEmissionFilterLink> toRemove = findFilterSetEmissionFilterLink( removal );
        java.util.Iterator<ome.model.acquisition.FilterSetEmissionFilterLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeFilterSetEmissionFilterLink( it.next(), true );
        }
    }

    /**
     * removes the given FilterSetEmissionFilterLink from emissionFilterLink, allowing for recursion -- whether
     * or not the removal will call unlinkFilter again <b>if loaded</b>.
     */
    public void removeFilterSetEmissionFilterLink (ome.model.acquisition.FilterSetEmissionFilterLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getEmissionFilterLink() == null ) {
            throwNullCollectionException("EmissionFilterLink");
        }

        getEmissionFilterLink().remove( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().removeFilterSetEmissionFilterLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearEmissionFilterLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.acquisition.FilterSetEmissionFilterLink> list = new java.util.ArrayList<ome.model.acquisition.FilterSetEmissionFilterLink>( getEmissionFilterLink() );
        for (ome.model.acquisition.FilterSetEmissionFilterLink link : list) {
            removeFilterSetEmissionFilterLink( link, true );
        }
    }

    private java.util.Map<Long, Long> emissionFilterLinkCountPerOwner = null;

    protected void setEmissionFilterLinkCountPerOwner(java.util.Map<Long, Long> map) {
        this.emissionFilterLinkCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Filter_emissionFilterLink_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.acquisition.FilterSetEmissionFilterLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Filter_emissionFilterLink") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Filter_emissionFilterLink_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Filter_id"))
    public java.util.Map<Long, Long> getEmissionFilterLinkCountPerOwner() {
        return this.emissionFilterLinkCountPerOwner;
    }

    protected java.util.Set<ome.model.annotations.FilterAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.FilterAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "filter_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "filter_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "filter_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "filter_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.acquisition.Filter.annotationLinks (ome.model.annotations.FilterAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.FilterAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.FilterAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.FilterAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.FilterAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.annotations.FilterAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.FilterAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.FilterAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.FilterAnnotationLink as well.
     */
    public void addFilterAnnotationLink(ome.model.annotations.FilterAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addFilterAnnotationLink.
     */
    public void addFilterAnnotationLinkSet(java.util.Collection<ome.model.annotations.FilterAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.FilterAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.FilterAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.FilterAnnotationLink
     */
    public void removeFilterAnnotationLink(ome.model.annotations.FilterAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeFilterAnnotationLink
     */
    public void removeFilterAnnotationLinkSet(java.util.Collection<ome.model.annotations.FilterAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.FilterAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.FilterAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.FilterAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.FilterAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.FilterAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.FilterAnnotationLink link = new ome.model.annotations.FilterAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addFilterAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.FilterAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addFilterAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addFilterAnnotationLink (ome.model.annotations.FilterAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.FilterAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.FilterAnnotationLink link = (ome.model.annotations.FilterAnnotationLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.FilterAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.FilterAnnotationLink> findFilterAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.FilterAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.FilterAnnotationLink> result = new java.util.HashSet<ome.model.annotations.FilterAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.FilterAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.FilterAnnotationLink> toRemove = findFilterAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.FilterAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeFilterAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given FilterAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkFilter again <b>if loaded</b>.
     */
    public void removeFilterAnnotationLink (ome.model.annotations.FilterAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.FilterAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.FilterAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.FilterAnnotationLink link : list) {
            removeFilterAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Filter_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.FilterAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Filter_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Filter_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Filter_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.acquisition.Filter newInstance()
    {
        return new ome.model.acquisition.Filter();
    }

    public ome.model.acquisition.Filter proxy() {
        return new ome.model.acquisition.Filter(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.manufacturer = (java.lang.String) __filter.filter(MANUFACTURER, this.manufacturer );
            this.model = (java.lang.String) __filter.filter(MODEL, this.model );
            this.lotNumber = (java.lang.String) __filter.filter(LOTNUMBER, this.lotNumber );
            this.serialNumber = (java.lang.String) __filter.filter(SERIALNUMBER, this.serialNumber );
            this.filterWheel = (java.lang.String) __filter.filter(FILTERWHEEL, this.filterWheel );
            this.type = (ome.model.enums.FilterType) __filter.filter(TYPE, this.type );
            this.transmittanceRange = (ome.model.acquisition.TransmittanceRange) __filter.filter(TRANSMITTANCERANGE, this.transmittanceRange );
            this.instrument = (ome.model.acquisition.Instrument) __filter.filter(INSTRUMENT, this.instrument );
            this.excitationFilterLinkCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(EXCITATIONFILTERLINKCOUNTPEROWNER, this.excitationFilterLinkCountPerOwner );
            this.excitationFilterLink = (java.util.Set<ome.model.acquisition.FilterSetExcitationFilterLink>) __filter.filter(EXCITATIONFILTERLINK, this.excitationFilterLink );
            this.emissionFilterLinkCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(EMISSIONFILTERLINKCOUNTPEROWNER, this.emissionFilterLinkCountPerOwner );
            this.emissionFilterLink = (java.util.Set<ome.model.acquisition.FilterSetEmissionFilterLink>) __filter.filter(EMISSIONFILTERLINK, this.emissionFilterLink );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.FilterAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.acquisition.Filter.FIELDS;
    }

    public final static String MANUFACTURER = "ome.model.acquisition.Filter_manufacturer";
    public final static String MODEL = "ome.model.acquisition.Filter_model";
    public final static String LOTNUMBER = "ome.model.acquisition.Filter_lotNumber";
    public final static String SERIALNUMBER = "ome.model.acquisition.Filter_serialNumber";
    public final static String FILTERWHEEL = "ome.model.acquisition.Filter_filterWheel";
    public final static String TYPE = "ome.model.acquisition.Filter_type";
    public final static String TRANSMITTANCERANGE = "ome.model.acquisition.Filter_transmittanceRange";
    public final static String INSTRUMENT = "ome.model.acquisition.Filter_instrument";
    public final static String EXCITATIONFILTERLINKCOUNTPEROWNER = "ome.model.acquisition.Filter_excitationFilterLinkCountPerOwner";
    public final static String EXCITATIONFILTERLINK = "ome.model.acquisition.Filter_excitationFilterLink";
    public final static String EMISSIONFILTERLINKCOUNTPEROWNER = "ome.model.acquisition.Filter_emissionFilterLinkCountPerOwner";
    public final static String EMISSIONFILTERLINK = "ome.model.acquisition.Filter_emissionFilterLink";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.acquisition.Filter_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.acquisition.Filter_annotationLinks";
    public final static String DETAILS = "ome.model.acquisition.Filter_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(MANUFACTURER);
       raw.add(MODEL);
       raw.add(LOTNUMBER);
       raw.add(SERIALNUMBER);
       raw.add(FILTERWHEEL);
       raw.add(TYPE);
       raw.add(TRANSMITTANCERANGE);
       raw.add(INSTRUMENT);
       raw.add(EXCITATIONFILTERLINKCOUNTPEROWNER);
       raw.add(EXCITATIONFILTERLINK);
       raw.add(EMISSIONFILTERLINKCOUNTPEROWNER);
       raw.add(EMISSIONFILTERLINK);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(MANUFACTURER)) {
            return getManufacturer();
        } else if (field.equals(MODEL)) {
            return getModel();
        } else if (field.equals(LOTNUMBER)) {
            return getLotNumber();
        } else if (field.equals(SERIALNUMBER)) {
            return getSerialNumber();
        } else if (field.equals(FILTERWHEEL)) {
            return getFilterWheel();
        } else if (field.equals(TYPE)) {
            return getType();
        } else if (field.equals(TRANSMITTANCERANGE)) {
            return getTransmittanceRange();
        } else if (field.equals(INSTRUMENT)) {
            return getInstrument();
        } else if (field.equals(EXCITATIONFILTERLINKCOUNTPEROWNER)) {
            return getExcitationFilterLinkCountPerOwner();
        } else if (field.equals(EXCITATIONFILTERLINK)) {
            return getExcitationFilterLink();
        } else if (field.equals(EMISSIONFILTERLINKCOUNTPEROWNER)) {
            return getEmissionFilterLinkCountPerOwner();
        } else if (field.equals(EMISSIONFILTERLINK)) {
            return getEmissionFilterLink();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) {
            return getAnnotationLinks();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(MANUFACTURER)) {
            setManufacturer((java.lang.String)value);
        } else if (field.equals(MODEL)) {
            setModel((java.lang.String)value);
        } else if (field.equals(LOTNUMBER)) {
            setLotNumber((java.lang.String)value);
        } else if (field.equals(SERIALNUMBER)) {
            setSerialNumber((java.lang.String)value);
        } else if (field.equals(FILTERWHEEL)) {
            setFilterWheel((java.lang.String)value);
        } else if (field.equals(TYPE)) {
            setType((ome.model.enums.FilterType)value);
        } else if (field.equals(TRANSMITTANCERANGE)) {
            setTransmittanceRange((ome.model.acquisition.TransmittanceRange)value);
        } else if (field.equals(INSTRUMENT)) {
            setInstrument((ome.model.acquisition.Instrument)value);
        } else if (field.equals(EXCITATIONFILTERLINKCOUNTPEROWNER)) {
            setExcitationFilterLinkCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(EXCITATIONFILTERLINK)) {
            setExcitationFilterLink((java.util.Set<ome.model.acquisition.FilterSetExcitationFilterLink>)value);
        } else if (field.equals(EMISSIONFILTERLINKCOUNTPEROWNER)) {
            setEmissionFilterLinkCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(EMISSIONFILTERLINK)) {
            setEmissionFilterLink((java.util.Set<ome.model.acquisition.FilterSetEmissionFilterLink>)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.FilterAnnotationLink>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.manufacturer = null;
        this.model = null;
        this.lotNumber = null;
        this.serialNumber = null;
        this.filterWheel = null;
        this.type = null;
        this.transmittanceRange = null;
        this.instrument = null;
        this.excitationFilterLinkCountPerOwner = null;
        this.excitationFilterLink = null;
        this.emissionFilterLinkCountPerOwner = null;
        this.emissionFilterLink = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfilter_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfilter_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKfilter_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfilter_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfilter_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
