

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.annotations;

import ome.conditions.*;
import ome.model.*;

@javax.persistence.Entity
@javax.persistence.DiscriminatorValue("/basic/num/")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public abstract class NumericAnnotation
extends ome.model.annotations.BasicAnnotation implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "numericannotation_owner_filter";
    public final static String GROUP_FILTER = "numericannotation_group_filter";
    public final static String EVENT_FILTER = "numericannotation_event_filter";
    public final static String PERMS_FILTER = "numericannotation_perms_filter";

    public NumericAnnotation () {
        this(null, true);
    }

    protected NumericAnnotation (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public NumericAnnotation (Long id, boolean loaded) {
        super(id, loaded);
    }




   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */


    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }


    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            return super.acceptFilter(__filter);
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.annotations.NumericAnnotation.FIELDS;
    }


    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else {
            return super.retrieve(field);
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else {
            super.putAt(field,value);
        }
    }


    @Override
    public void unload() {
        _loaded = false;
        super.unload();
    }




    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





}
