

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.core;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="logicalchannel_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="logicalchannel_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="logicalchannel_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="logicalchannel_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="logicalchannel_owner_filter_CHANNELS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="logicalchannel_group_filter_CHANNELS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="logicalchannel_event_filter_CHANNELS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="logicalchannel_perms_filter_CHANNELS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="logicalchannel_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="logicalchannel_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="logicalchannel_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="logicalchannel_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
        "id IN (SELECT channel.logicalchannel FROM channel*, pixels* WHERE " +
        "channel.pixels = pixels.id AND pixels.image IN (:images)))")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "logicalchannel", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_logicalchannel",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_logicalchannel"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class LogicalChannel
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "logicalchannel_owner_filter";
    public final static String GROUP_FILTER = "logicalchannel_group_filter";
    public final static String EVENT_FILTER = "logicalchannel_event_filter";
    public final static String PERMS_FILTER = "logicalchannel_perms_filter";

    public LogicalChannel () {
        this(null, true);
    }

    protected LogicalChannel (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public LogicalChannel (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }



    public final static String ID = "ome.model.core.LogicalChannel_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_logicalchannel") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.core.LogicalChannel_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.core.LogicalChannel.name (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected ome.model.units.Length pinHoleSize = null;

 
   /**
    * Enum-mapped unit-based field ome.model.core.LogicalChannel.pinHoleSize (ome.model.units.Length)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="pinHoleSize") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="pinHoleSizeUnit") )
    } )
    public ome.model.units.Length getPinHoleSize() {
        if (! _loaded ) errorIfUnloaded();
        return this.pinHoleSize;
    }

    public void setPinHoleSize(ome.model.units.Length pinHoleSize) {
        if (! _loaded ) errorIfUnloaded();
        this.pinHoleSize = pinHoleSize;
    }

    protected ome.model.enums.Illumination illumination = null;

   /**
    * Many-to-one field ome.model.core.LogicalChannel.illumination (ome.model.enums.Illumination)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.Illumination.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="illumination", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlogicalchannel_illumination_illumination")
    public ome.model.enums.Illumination getIllumination() {
        if (! _loaded ) errorIfUnloaded();
        return this.illumination;
    }

    public void setIllumination(ome.model.enums.Illumination illumination) {
        if (! _loaded ) errorIfUnloaded();
        this.illumination = illumination;
    }
    protected ome.model.enums.ContrastMethod contrastMethod = null;

   /**
    * Many-to-one field ome.model.core.LogicalChannel.contrastMethod (ome.model.enums.ContrastMethod)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.ContrastMethod.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="contrastMethod", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlogicalchannel_contrastMethod_contrastmethod")
    public ome.model.enums.ContrastMethod getContrastMethod() {
        if (! _loaded ) errorIfUnloaded();
        return this.contrastMethod;
    }

    public void setContrastMethod(ome.model.enums.ContrastMethod contrastMethod) {
        if (! _loaded ) errorIfUnloaded();
        this.contrastMethod = contrastMethod;
    }
    protected ome.model.units.Length excitationWave = null;

 
   /**
    * Enum-mapped unit-based field ome.model.core.LogicalChannel.excitationWave (ome.model.units.Length)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="excitationWave") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="excitationWaveUnit") )
    } )
    public ome.model.units.Length getExcitationWave() {
        if (! _loaded ) errorIfUnloaded();
        return this.excitationWave;
    }

    public void setExcitationWave(ome.model.units.Length excitationWave) {
        if (! _loaded ) errorIfUnloaded();
        if (excitationWave != null && excitationWave.getValue() <= 0) {
            throw new IllegalArgumentException("values of LogicalChannel.excitationWave must be strictly positive");
        }
        this.excitationWave = excitationWave;
    }

    protected ome.model.units.Length emissionWave = null;

 
   /**
    * Enum-mapped unit-based field ome.model.core.LogicalChannel.emissionWave (ome.model.units.Length)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="emissionWave") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="emissionWaveUnit") )
    } )
    public ome.model.units.Length getEmissionWave() {
        if (! _loaded ) errorIfUnloaded();
        return this.emissionWave;
    }

    public void setEmissionWave(ome.model.units.Length emissionWave) {
        if (! _loaded ) errorIfUnloaded();
        if (emissionWave != null && emissionWave.getValue() <= 0) {
            throw new IllegalArgumentException("values of LogicalChannel.emissionWave must be strictly positive");
        }
        this.emissionWave = emissionWave;
    }

    protected java.lang.String fluor = null;

   /**
    * Simple field ome.model.core.LogicalChannel.fluor (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fluor", updatable=true)
    public java.lang.String getFluor() {
        if (! _loaded ) errorIfUnloaded();
        return this.fluor;
    }

    public void setFluor(java.lang.String fluor) {
        if (! _loaded ) errorIfUnloaded();
        this.fluor = (java.lang.String) fluor;
    }
    protected java.lang.Double ndFilter = null;

   /**
    * Simple field ome.model.core.LogicalChannel.ndFilter (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="ndFilter", updatable=true)
    public java.lang.Double getNdFilter() {
        if (! _loaded ) errorIfUnloaded();
        return this.ndFilter;
    }

    public void setNdFilter(java.lang.Double ndFilter) {
        if (! _loaded ) errorIfUnloaded();
        this.ndFilter = (java.lang.Double) ndFilter;
    }
    protected ome.model.acquisition.OTF otf = null;

   /**
    * Many-to-one field ome.model.core.LogicalChannel.otf (ome.model.acquisition.OTF)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.OTF.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="otf", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlogicalchannel_otf_otf")
    public ome.model.acquisition.OTF getOtf() {
        if (! _loaded ) errorIfUnloaded();
        return this.otf;
    }

    public void setOtf(ome.model.acquisition.OTF otf) {
        if (! _loaded ) errorIfUnloaded();
        this.otf = otf;
    }
    protected ome.model.acquisition.DetectorSettings detectorSettings = null;

   /**
    * Many-to-one field ome.model.core.LogicalChannel.detectorSettings (ome.model.acquisition.DetectorSettings)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.DetectorSettings.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="detectorSettings", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlogicalchannel_detectorSettings_detectorsettings")
    public ome.model.acquisition.DetectorSettings getDetectorSettings() {
        if (! _loaded ) errorIfUnloaded();
        return this.detectorSettings;
    }

    public void setDetectorSettings(ome.model.acquisition.DetectorSettings detectorSettings) {
        if (! _loaded ) errorIfUnloaded();
        this.detectorSettings = detectorSettings;
    }
    protected ome.model.acquisition.LightSettings lightSourceSettings = null;

   /**
    * Many-to-one field ome.model.core.LogicalChannel.lightSourceSettings (ome.model.acquisition.LightSettings)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.LightSettings.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="lightSourceSettings", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlogicalchannel_lightSourceSettings_lightsettings")
    public ome.model.acquisition.LightSettings getLightSourceSettings() {
        if (! _loaded ) errorIfUnloaded();
        return this.lightSourceSettings;
    }

    public void setLightSourceSettings(ome.model.acquisition.LightSettings lightSourceSettings) {
        if (! _loaded ) errorIfUnloaded();
        this.lightSourceSettings = lightSourceSettings;
    }
    protected ome.model.acquisition.FilterSet filterSet = null;

   /**
    * Many-to-one field ome.model.core.LogicalChannel.filterSet (ome.model.acquisition.FilterSet)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.FilterSet.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="filterSet", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlogicalchannel_filterSet_filterset")
    public ome.model.acquisition.FilterSet getFilterSet() {
        if (! _loaded ) errorIfUnloaded();
        return this.filterSet;
    }

    public void setFilterSet(ome.model.acquisition.FilterSet filterSet) {
        if (! _loaded ) errorIfUnloaded();
        this.filterSet = filterSet;
    }
    protected java.lang.Integer samplesPerPixel = null;

   /**
    * Simple field ome.model.core.LogicalChannel.samplesPerPixel (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="positive_int", nullable=true, unique=false, name="samplesPerPixel", updatable=true)
    public java.lang.Integer getSamplesPerPixel() {
        if (! _loaded ) errorIfUnloaded();
        return this.samplesPerPixel;
    }

    public void setSamplesPerPixel(java.lang.Integer samplesPerPixel) {
        if (! _loaded ) errorIfUnloaded();
        if (samplesPerPixel != null && samplesPerPixel <= 0) {
            throw new IllegalArgumentException("values of LogicalChannel.samplesPerPixel must be strictly positive");
        }
        this.samplesPerPixel = (java.lang.Integer) samplesPerPixel;
    }
    protected ome.model.enums.PhotometricInterpretation photometricInterpretation = null;

   /**
    * Many-to-one field ome.model.core.LogicalChannel.photometricInterpretation (ome.model.enums.PhotometricInterpretation)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.PhotometricInterpretation.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="photometricInterpretation", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlogicalchannel_photometricInterpretation_photometricinterpretation")
    public ome.model.enums.PhotometricInterpretation getPhotometricInterpretation() {
        if (! _loaded ) errorIfUnloaded();
        return this.photometricInterpretation;
    }

    public void setPhotometricInterpretation(ome.model.enums.PhotometricInterpretation photometricInterpretation) {
        if (! _loaded ) errorIfUnloaded();
        this.photometricInterpretation = photometricInterpretation;
    }
    protected ome.model.enums.AcquisitionMode mode = null;

   /**
    * Many-to-one field ome.model.core.LogicalChannel.mode (ome.model.enums.AcquisitionMode)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.AcquisitionMode.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="\"mode\"", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlogicalchannel_mode_acquisitionmode")
    public ome.model.enums.AcquisitionMode getMode() {
        if (! _loaded ) errorIfUnloaded();
        return this.mode;
    }

    public void setMode(ome.model.enums.AcquisitionMode mode) {
        if (! _loaded ) errorIfUnloaded();
        this.mode = mode;
    }
    protected java.lang.Integer pockelCellSetting = null;

   /**
    * Simple field ome.model.core.LogicalChannel.pockelCellSetting (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="pockelCellSetting", updatable=true)
    public java.lang.Integer getPockelCellSetting() {
        if (! _loaded ) errorIfUnloaded();
        return this.pockelCellSetting;
    }

    public void setPockelCellSetting(java.lang.Integer pockelCellSetting) {
        if (! _loaded ) errorIfUnloaded();
        this.pockelCellSetting = (java.lang.Integer) pockelCellSetting;
    }
    protected java.util.Set<ome.model.core.Channel> channels = new java.util.HashSet<ome.model.core.Channel>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_CHANNELS = "logicalchannel_owner_filter_CHANNELS";
    public final static String GROUP_FILTER_CHANNELS = "logicalchannel_group_filter_CHANNELS";
    public final static String EVENT_FILTER_CHANNELS = "logicalchannel_event_filter_CHANNELS";
    public final static String PERMS_FILTER_CHANNELS = "logicalchannel_perms_filter_CHANNELS";

   /**
    * returns channels . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.core.LogicalChannel.channels (ome.model.core.Channel)
    */
    @javax.persistence.OneToMany(mappedBy="logicalChannel", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
            "id IN (SELECT channel.id FROM channel*, pixels* WHERE " +
            "channel.pixels = pixels.id AND pixels.image IN (:images)))"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_CHANNELS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_CHANNELS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_CHANNELS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_CHANNELS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.core.Channel> getChannels() {
        if (! _loaded ) errorIfUnloaded();
        return this.channels;
    }

    /**
     * setter for channels should be avoided. Does not fulfill normal semantics.
     */
    protected void setChannels(java.util.Set<ome.model.core.Channel> channels) {
        if (! _loaded ) errorIfUnloaded();
        this.channels = channels;
    }
    /**
     * returns the size of channels. If less than zero, the Set was null.
     */
    public int sizeOfChannels() {
        if (! _loaded ) errorIfUnloaded();
        return this.channels == null ? -1 : this.channels.size();
    }

    /**
     * should be used rather than accessing the channels set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfChannels()} is less than zero.
     */
    public java.util.Iterator<ome.model.core.Channel> iterateChannels() {
        if (! _loaded ) errorIfUnloaded();
        if ( getChannels() == null ) {
            return new ome.util.EmptyIterator<ome.model.core.Channel>();
        }
        return getChannels().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.core.Channel> unmodifiableChannels() {
        if (! _loaded ) errorIfUnloaded();
        if ( getChannels() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getChannels() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.core.Channel while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateChannels} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectChannels(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.core.Channel> it = iterateChannels();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setChannels . Makes the necessary
     * call on ome.model.core.Channel as well.
     */
    public void addChannel(ome.model.core.Channel target) {
        if (! _loaded ) errorIfUnloaded();
        if (getChannels() == null) {
            throwNullCollectionException("Channels");
        }
        getChannels().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setLogicalChannel ( this );
         }
    }

    /**
     * use like addChannel.
     */
    public void addChannelSet(java.util.Collection<ome.model.core.Channel> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getChannels() == null) {
           throwNullCollectionException("Channels");
        }
        getChannels().addAll( targets );
        java.util.Iterator<ome.model.core.Channel> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.core.Channel target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setLogicalChannel ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.core.Channel
     */
    public void removeChannel(ome.model.core.Channel target) {
        if (! _loaded ) errorIfUnloaded();
        if (getChannels() == null) {
            throwNullCollectionException("Channels");
        }
        getChannels().remove( target );
            target.setLogicalChannel ( null );
    }

    /**
     * use like removeChannel
     */
    public void removeChannelSet(java.util.Collection<ome.model.core.Channel> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getChannels() == null) {
            throwNullCollectionException("Channels");
        }
        getChannels().removeAll( targets );
        java.util.Iterator<ome.model.core.Channel> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.core.Channel target = it.next();
                target.setLogicalChannel ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearChannels() {
        if (! _loaded ) errorIfUnloaded();
        if (getChannels() == null) {
            throwNullCollectionException("Channels");
        }
        getChannels().clear();
        java.util.Iterator<ome.model.core.Channel> it = iterateChannels();
        while (it.hasNext()) {
            ome.model.core.Channel target = it.next();
            target.setLogicalChannel ( null );
        }
    }


    protected ome.model.acquisition.LightPath lightPath = null;

   /**
    * Many-to-one field ome.model.core.LogicalChannel.lightPath (ome.model.acquisition.LightPath)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.LightPath.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="lightPath", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKlogicalchannel_lightPath_lightpath")
    public ome.model.acquisition.LightPath getLightPath() {
        if (! _loaded ) errorIfUnloaded();
        return this.lightPath;
    }

    public void setLightPath(ome.model.acquisition.LightPath lightPath) {
        if (! _loaded ) errorIfUnloaded();
        this.lightPath = lightPath;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.core.LogicalChannel newInstance()
    {
        return new ome.model.core.LogicalChannel();
    }

    public ome.model.core.LogicalChannel proxy() {
        return new ome.model.core.LogicalChannel(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.pinHoleSize = (ome.model.units.Length) __filter.filter(PINHOLESIZE, this.pinHoleSize );
            this.illumination = (ome.model.enums.Illumination) __filter.filter(ILLUMINATION, this.illumination );
            this.contrastMethod = (ome.model.enums.ContrastMethod) __filter.filter(CONTRASTMETHOD, this.contrastMethod );
            this.excitationWave = (ome.model.units.Length) __filter.filter(EXCITATIONWAVE, this.excitationWave );
            this.emissionWave = (ome.model.units.Length) __filter.filter(EMISSIONWAVE, this.emissionWave );
            this.fluor = (java.lang.String) __filter.filter(FLUOR, this.fluor );
            this.ndFilter = (java.lang.Double) __filter.filter(NDFILTER, this.ndFilter );
            this.otf = (ome.model.acquisition.OTF) __filter.filter(OTF, this.otf );
            this.detectorSettings = (ome.model.acquisition.DetectorSettings) __filter.filter(DETECTORSETTINGS, this.detectorSettings );
            this.lightSourceSettings = (ome.model.acquisition.LightSettings) __filter.filter(LIGHTSOURCESETTINGS, this.lightSourceSettings );
            this.filterSet = (ome.model.acquisition.FilterSet) __filter.filter(FILTERSET, this.filterSet );
            this.samplesPerPixel = (java.lang.Integer) __filter.filter(SAMPLESPERPIXEL, this.samplesPerPixel );
            this.photometricInterpretation = (ome.model.enums.PhotometricInterpretation) __filter.filter(PHOTOMETRICINTERPRETATION, this.photometricInterpretation );
            this.mode = (ome.model.enums.AcquisitionMode) __filter.filter(MODE, this.mode );
            this.pockelCellSetting = (java.lang.Integer) __filter.filter(POCKELCELLSETTING, this.pockelCellSetting );
            this.channels = (java.util.Set<ome.model.core.Channel>) __filter.filter(CHANNELS, this.channels );
            this.lightPath = (ome.model.acquisition.LightPath) __filter.filter(LIGHTPATH, this.lightPath );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.core.LogicalChannel.FIELDS;
    }

    public final static String NAME = "ome.model.core.LogicalChannel_name";
    public final static String PINHOLESIZE = "ome.model.core.LogicalChannel_pinHoleSize";
    public final static String ILLUMINATION = "ome.model.core.LogicalChannel_illumination";
    public final static String CONTRASTMETHOD = "ome.model.core.LogicalChannel_contrastMethod";
    public final static String EXCITATIONWAVE = "ome.model.core.LogicalChannel_excitationWave";
    public final static String EMISSIONWAVE = "ome.model.core.LogicalChannel_emissionWave";
    public final static String FLUOR = "ome.model.core.LogicalChannel_fluor";
    public final static String NDFILTER = "ome.model.core.LogicalChannel_ndFilter";
    public final static String OTF = "ome.model.core.LogicalChannel_otf";
    public final static String DETECTORSETTINGS = "ome.model.core.LogicalChannel_detectorSettings";
    public final static String LIGHTSOURCESETTINGS = "ome.model.core.LogicalChannel_lightSourceSettings";
    public final static String FILTERSET = "ome.model.core.LogicalChannel_filterSet";
    public final static String SAMPLESPERPIXEL = "ome.model.core.LogicalChannel_samplesPerPixel";
    public final static String PHOTOMETRICINTERPRETATION = "ome.model.core.LogicalChannel_photometricInterpretation";
    public final static String MODE = "ome.model.core.LogicalChannel_mode";
    public final static String POCKELCELLSETTING = "ome.model.core.LogicalChannel_pockelCellSetting";
    public final static String CHANNELS = "ome.model.core.LogicalChannel_channels";
    public final static String LIGHTPATH = "ome.model.core.LogicalChannel_lightPath";
    public final static String DETAILS = "ome.model.core.LogicalChannel_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(NAME);
       raw.add(PINHOLESIZE);
       raw.add(ILLUMINATION);
       raw.add(CONTRASTMETHOD);
       raw.add(EXCITATIONWAVE);
       raw.add(EMISSIONWAVE);
       raw.add(FLUOR);
       raw.add(NDFILTER);
       raw.add(OTF);
       raw.add(DETECTORSETTINGS);
       raw.add(LIGHTSOURCESETTINGS);
       raw.add(FILTERSET);
       raw.add(SAMPLESPERPIXEL);
       raw.add(PHOTOMETRICINTERPRETATION);
       raw.add(MODE);
       raw.add(POCKELCELLSETTING);
       raw.add(CHANNELS);
       raw.add(LIGHTPATH);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(NAME)) {
            return getName();
        } else if (field.equals(PINHOLESIZE)) {
            return getPinHoleSize();
        } else if (field.equals(ILLUMINATION)) {
            return getIllumination();
        } else if (field.equals(CONTRASTMETHOD)) {
            return getContrastMethod();
        } else if (field.equals(EXCITATIONWAVE)) {
            return getExcitationWave();
        } else if (field.equals(EMISSIONWAVE)) {
            return getEmissionWave();
        } else if (field.equals(FLUOR)) {
            return getFluor();
        } else if (field.equals(NDFILTER)) {
            return getNdFilter();
        } else if (field.equals(OTF)) {
            return getOtf();
        } else if (field.equals(DETECTORSETTINGS)) {
            return getDetectorSettings();
        } else if (field.equals(LIGHTSOURCESETTINGS)) {
            return getLightSourceSettings();
        } else if (field.equals(FILTERSET)) {
            return getFilterSet();
        } else if (field.equals(SAMPLESPERPIXEL)) {
            return getSamplesPerPixel();
        } else if (field.equals(PHOTOMETRICINTERPRETATION)) {
            return getPhotometricInterpretation();
        } else if (field.equals(MODE)) {
            return getMode();
        } else if (field.equals(POCKELCELLSETTING)) {
            return getPockelCellSetting();
        } else if (field.equals(CHANNELS)) {
            return getChannels();
        } else if (field.equals(LIGHTPATH)) {
            return getLightPath();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(PINHOLESIZE)) {
            setPinHoleSize((ome.model.units.Length)value);
        } else if (field.equals(ILLUMINATION)) {
            setIllumination((ome.model.enums.Illumination)value);
        } else if (field.equals(CONTRASTMETHOD)) {
            setContrastMethod((ome.model.enums.ContrastMethod)value);
        } else if (field.equals(EXCITATIONWAVE)) {
            setExcitationWave((ome.model.units.Length)value);
        } else if (field.equals(EMISSIONWAVE)) {
            setEmissionWave((ome.model.units.Length)value);
        } else if (field.equals(FLUOR)) {
            setFluor((java.lang.String)value);
        } else if (field.equals(NDFILTER)) {
            setNdFilter((java.lang.Double)value);
        } else if (field.equals(OTF)) {
            setOtf((ome.model.acquisition.OTF)value);
        } else if (field.equals(DETECTORSETTINGS)) {
            setDetectorSettings((ome.model.acquisition.DetectorSettings)value);
        } else if (field.equals(LIGHTSOURCESETTINGS)) {
            setLightSourceSettings((ome.model.acquisition.LightSettings)value);
        } else if (field.equals(FILTERSET)) {
            setFilterSet((ome.model.acquisition.FilterSet)value);
        } else if (field.equals(SAMPLESPERPIXEL)) {
            setSamplesPerPixel((java.lang.Integer)value);
        } else if (field.equals(PHOTOMETRICINTERPRETATION)) {
            setPhotometricInterpretation((ome.model.enums.PhotometricInterpretation)value);
        } else if (field.equals(MODE)) {
            setMode((ome.model.enums.AcquisitionMode)value);
        } else if (field.equals(POCKELCELLSETTING)) {
            setPockelCellSetting((java.lang.Integer)value);
        } else if (field.equals(CHANNELS)) {
            setChannels((java.util.Set<ome.model.core.Channel>)value);
        } else if (field.equals(LIGHTPATH)) {
            setLightPath((ome.model.acquisition.LightPath)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.name = null;
        this.pinHoleSize = null;
        this.illumination = null;
        this.contrastMethod = null;
        this.excitationWave = null;
        this.emissionWave = null;
        this.fluor = null;
        this.ndFilter = null;
        this.otf = null;
        this.detectorSettings = null;
        this.lightSourceSettings = null;
        this.filterSet = null;
        this.samplesPerPixel = null;
        this.photometricInterpretation = null;
        this.mode = null;
        this.pockelCellSetting = null;
        this.channels = null;
        this.lightPath = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKlogicalchannel_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKlogicalchannel_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKlogicalchannel_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKlogicalchannel_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKlogicalchannel_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
