

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.display;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="projectiondef_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="projectiondef_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="projectiondef_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="projectiondef_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="projectiondef_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="projectiondef_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="projectiondef_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="projectiondef_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
        "id IN (SELECT projectiondef.id FROM projectiondef*, renderingdef*, pixels* WHERE " +
        "projectiondef.renderingdef = renderingdef.id AND renderingdef.pixels = pixels.id AND pixels.image IN (:images)))")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "projectiondef", uniqueConstraints = {
     @javax.persistence.UniqueConstraint(columnNames={"renderingDef","renderingDef_index"})
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_projectiondef",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_projectiondef"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class ProjectionDef
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "projectiondef_owner_filter";
    public final static String GROUP_FILTER = "projectiondef_group_filter";
    public final static String EVENT_FILTER = "projectiondef_event_filter";
    public final static String PERMS_FILTER = "projectiondef_perms_filter";

    public ProjectionDef () {
        this(null, true);
    }

    protected ProjectionDef (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public ProjectionDef (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public ProjectionDef(
ome.model.display.RenderingDef _renderingDef,ome.model.enums.ProjectionAxis _axis,ome.model.enums.ProjectionType _type,java.lang.Boolean _active    ) {
        this(null, true);
        setRenderingDef(_renderingDef);
        setAxis(_axis);
        setType(_type);
        setActive(_active);
    }

    public final static String ID = "ome.model.display.ProjectionDef_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_projectiondef") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.display.ProjectionDef_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected ome.model.display.RenderingDef renderingDef = null;

   /**
    * Many-to-one field ome.model.display.ProjectionDef.renderingDef (ome.model.display.RenderingDef)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.display.RenderingDef.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="renderingDef", nullable=false,
        unique=false, insertable=false, updatable=false)
    @org.hibernate.annotations.ForeignKey(name="FKprojectiondef_renderingDef_renderingdef")
    public ome.model.display.RenderingDef getRenderingDef() {
        if (! _loaded ) errorIfUnloaded();
        return this.renderingDef;
    }

    public void setRenderingDef(ome.model.display.RenderingDef renderingDef) {
        if (! _loaded ) errorIfUnloaded();
        this.renderingDef = renderingDef;
    }
    protected ome.model.enums.ProjectionAxis axis = null;

   /**
    * Many-to-one field ome.model.display.ProjectionDef.axis (ome.model.enums.ProjectionAxis)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.ProjectionAxis.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="axis", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKprojectiondef_axis_projectionaxis")
    public ome.model.enums.ProjectionAxis getAxis() {
        if (! _loaded ) errorIfUnloaded();
        return this.axis;
    }

    public void setAxis(ome.model.enums.ProjectionAxis axis) {
        if (! _loaded ) errorIfUnloaded();
        this.axis = axis;
    }
    protected ome.model.enums.ProjectionType type = null;

   /**
    * Many-to-one field ome.model.display.ProjectionDef.type (ome.model.enums.ProjectionType)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.ProjectionType.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="type", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKprojectiondef_type_projectiontype")
    public ome.model.enums.ProjectionType getType() {
        if (! _loaded ) errorIfUnloaded();
        return this.type;
    }

    public void setType(ome.model.enums.ProjectionType type) {
        if (! _loaded ) errorIfUnloaded();
        this.type = type;
    }
    protected java.lang.Boolean active = null;

   /**
    * Simple field ome.model.display.ProjectionDef.active (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="active", updatable=true)
    public java.lang.Boolean getActive() {
        if (! _loaded ) errorIfUnloaded();
        return this.active;
    }

    public void setActive(java.lang.Boolean active) {
        if (! _loaded ) errorIfUnloaded();
        this.active = (java.lang.Boolean) active;
    }
    protected java.lang.Integer startPlane = null;

   /**
    * Simple field ome.model.display.ProjectionDef.startPlane (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="nonnegative_int", nullable=true, unique=false, name="startPlane", updatable=true)
    public java.lang.Integer getStartPlane() {
        if (! _loaded ) errorIfUnloaded();
        return this.startPlane;
    }

    public void setStartPlane(java.lang.Integer startPlane) {
        if (! _loaded ) errorIfUnloaded();
        if (startPlane != null && startPlane < 0) {
            throw new IllegalArgumentException("values of ProjectionDef.startPlane must not be negative");
        }
        this.startPlane = (java.lang.Integer) startPlane;
    }
    protected java.lang.Integer endPlane = null;

   /**
    * Simple field ome.model.display.ProjectionDef.endPlane (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="nonnegative_int", nullable=true, unique=false, name="endPlane", updatable=true)
    public java.lang.Integer getEndPlane() {
        if (! _loaded ) errorIfUnloaded();
        return this.endPlane;
    }

    public void setEndPlane(java.lang.Integer endPlane) {
        if (! _loaded ) errorIfUnloaded();
        if (endPlane != null && endPlane < 0) {
            throw new IllegalArgumentException("values of ProjectionDef.endPlane must not be negative");
        }
        this.endPlane = (java.lang.Integer) endPlane;
    }
    protected java.lang.Integer stepping = null;

   /**
    * Simple field ome.model.display.ProjectionDef.stepping (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="positive_int", nullable=true, unique=false, name="stepping", updatable=true)
    public java.lang.Integer getStepping() {
        if (! _loaded ) errorIfUnloaded();
        return this.stepping;
    }

    public void setStepping(java.lang.Integer stepping) {
        if (! _loaded ) errorIfUnloaded();
        if (stepping != null && stepping <= 0) {
            throw new IllegalArgumentException("values of ProjectionDef.stepping must be strictly positive");
        }
        this.stepping = (java.lang.Integer) stepping;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.display.ProjectionDef newInstance()
    {
        return new ome.model.display.ProjectionDef();
    }

    public ome.model.display.ProjectionDef proxy() {
        return new ome.model.display.ProjectionDef(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.renderingDef = (ome.model.display.RenderingDef) __filter.filter(RENDERINGDEF, this.renderingDef );
            this.axis = (ome.model.enums.ProjectionAxis) __filter.filter(AXIS, this.axis );
            this.type = (ome.model.enums.ProjectionType) __filter.filter(TYPE, this.type );
            this.active = (java.lang.Boolean) __filter.filter(ACTIVE, this.active );
            this.startPlane = (java.lang.Integer) __filter.filter(STARTPLANE, this.startPlane );
            this.endPlane = (java.lang.Integer) __filter.filter(ENDPLANE, this.endPlane );
            this.stepping = (java.lang.Integer) __filter.filter(STEPPING, this.stepping );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.display.ProjectionDef.FIELDS;
    }

    public final static String RENDERINGDEF = "ome.model.display.ProjectionDef_renderingDef";
    public final static String AXIS = "ome.model.display.ProjectionDef_axis";
    public final static String TYPE = "ome.model.display.ProjectionDef_type";
    public final static String ACTIVE = "ome.model.display.ProjectionDef_active";
    public final static String STARTPLANE = "ome.model.display.ProjectionDef_startPlane";
    public final static String ENDPLANE = "ome.model.display.ProjectionDef_endPlane";
    public final static String STEPPING = "ome.model.display.ProjectionDef_stepping";
    public final static String DETAILS = "ome.model.display.ProjectionDef_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(RENDERINGDEF);
       raw.add(AXIS);
       raw.add(TYPE);
       raw.add(ACTIVE);
       raw.add(STARTPLANE);
       raw.add(ENDPLANE);
       raw.add(STEPPING);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(RENDERINGDEF)) {
            return getRenderingDef();
        } else if (field.equals(AXIS)) {
            return getAxis();
        } else if (field.equals(TYPE)) {
            return getType();
        } else if (field.equals(ACTIVE)) {
            return getActive();
        } else if (field.equals(STARTPLANE)) {
            return getStartPlane();
        } else if (field.equals(ENDPLANE)) {
            return getEndPlane();
        } else if (field.equals(STEPPING)) {
            return getStepping();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(RENDERINGDEF)) {
            setRenderingDef((ome.model.display.RenderingDef)value);
        } else if (field.equals(AXIS)) {
            setAxis((ome.model.enums.ProjectionAxis)value);
        } else if (field.equals(TYPE)) {
            setType((ome.model.enums.ProjectionType)value);
        } else if (field.equals(ACTIVE)) {
            setActive((java.lang.Boolean)value);
        } else if (field.equals(STARTPLANE)) {
            setStartPlane((java.lang.Integer)value);
        } else if (field.equals(ENDPLANE)) {
            setEndPlane((java.lang.Integer)value);
        } else if (field.equals(STEPPING)) {
            setStepping((java.lang.Integer)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.renderingDef = null;
        this.axis = null;
        this.type = null;
        this.active = null;
        this.startPlane = null;
        this.endPlane = null;
        this.stepping = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKprojectiondef_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKprojectiondef_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKprojectiondef_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKprojectiondef_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKprojectiondef_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
