

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.roi;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="shape_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="shape_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="shape_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="shape_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="shape_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="shape_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="shape_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="shape_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="shape_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="shape_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="shape_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="shape_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "shape", uniqueConstraints = {
     @javax.persistence.UniqueConstraint(columnNames={"roi","roi_index"})
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.SINGLE_TABLE)
@javax.persistence.DiscriminatorValue("")
@javax.persistence.DiscriminatorColumn(
    name="discriminator", discriminatorType=javax.persistence.DiscriminatorType.STRING
)
@org.hibernate.annotations.GenericGenerator(name = "seq_shape",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_shape"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public abstract class Shape
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "shape_owner_filter";
    public final static String GROUP_FILTER = "shape_group_filter";
    public final static String EVENT_FILTER = "shape_event_filter";
    public final static String PERMS_FILTER = "shape_perms_filter";

    public Shape () {
        this(null, true);
    }

    protected Shape (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Shape (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Shape(
ome.model.roi.Roi _roi    ) {
        this(null, true);
        setRoi(_roi);
    }

    public final static String ID = "ome.model.roi.Shape_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_shape") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.roi.Shape_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.Integer theZ = null;

   /**
    * Simple field ome.model.roi.Shape.theZ (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="theZ", updatable=true)
    public java.lang.Integer getTheZ() {
        if (! _loaded ) errorIfUnloaded();
        return this.theZ;
    }

    public void setTheZ(java.lang.Integer theZ) {
        if (! _loaded ) errorIfUnloaded();
        this.theZ = (java.lang.Integer) theZ;
    }
    protected java.lang.Integer theT = null;

   /**
    * Simple field ome.model.roi.Shape.theT (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="theT", updatable=true)
    public java.lang.Integer getTheT() {
        if (! _loaded ) errorIfUnloaded();
        return this.theT;
    }

    public void setTheT(java.lang.Integer theT) {
        if (! _loaded ) errorIfUnloaded();
        this.theT = (java.lang.Integer) theT;
    }
    protected java.lang.Integer theC = null;

   /**
    * Simple field ome.model.roi.Shape.theC (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="theC", updatable=true)
    public java.lang.Integer getTheC() {
        if (! _loaded ) errorIfUnloaded();
        return this.theC;
    }

    public void setTheC(java.lang.Integer theC) {
        if (! _loaded ) errorIfUnloaded();
        this.theC = (java.lang.Integer) theC;
    }
    protected ome.model.roi.Roi roi = null;

   /**
    * Many-to-one field ome.model.roi.Shape.roi (ome.model.roi.Roi)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.EAGER, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.roi.Roi.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="roi", nullable=false,
        unique=false, insertable=false, updatable=false)
    @org.hibernate.annotations.ForeignKey(name="FKshape_roi_roi")
    public ome.model.roi.Roi getRoi() {
        if (! _loaded ) errorIfUnloaded();
        return this.roi;
    }

    public void setRoi(ome.model.roi.Roi roi) {
        if (! _loaded ) errorIfUnloaded();
        this.roi = roi;
    }
    protected java.lang.Boolean locked = null;

   /**
    * Simple field ome.model.roi.Shape.locked (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="locked", updatable=true)
    public java.lang.Boolean getLocked() {
        if (! _loaded ) errorIfUnloaded();
        return this.locked;
    }

    public void setLocked(java.lang.Boolean locked) {
        if (! _loaded ) errorIfUnloaded();
        this.locked = (java.lang.Boolean) locked;
    }
    protected ome.model.roi.AffineTransform transform = null;

   /**
    * Many-to-one field ome.model.roi.Shape.transform (ome.model.roi.AffineTransform)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.EAGER, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.roi.AffineTransform.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="transform", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKshape_transform_affinetransform")
    public ome.model.roi.AffineTransform getTransform() {
        if (! _loaded ) errorIfUnloaded();
        return this.transform;
    }

    public void setTransform(ome.model.roi.AffineTransform transform) {
        if (! _loaded ) errorIfUnloaded();
        this.transform = transform;
    }
    protected java.lang.Integer fillColor = null;

   /**
    * Simple field ome.model.roi.Shape.fillColor (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fillColor", updatable=true)
    public java.lang.Integer getFillColor() {
        if (! _loaded ) errorIfUnloaded();
        return this.fillColor;
    }

    public void setFillColor(java.lang.Integer fillColor) {
        if (! _loaded ) errorIfUnloaded();
        this.fillColor = (java.lang.Integer) fillColor;
    }
    protected java.lang.String fillRule = null;

   /**
    * Simple field ome.model.roi.Shape.fillRule (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fillRule", updatable=true)
    public java.lang.String getFillRule() {
        if (! _loaded ) errorIfUnloaded();
        return this.fillRule;
    }

    public void setFillRule(java.lang.String fillRule) {
        if (! _loaded ) errorIfUnloaded();
        this.fillRule = (java.lang.String) fillRule;
    }
    protected java.lang.Integer strokeColor = null;

   /**
    * Simple field ome.model.roi.Shape.strokeColor (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="strokeColor", updatable=true)
    public java.lang.Integer getStrokeColor() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeColor;
    }

    public void setStrokeColor(java.lang.Integer strokeColor) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeColor = (java.lang.Integer) strokeColor;
    }
    protected java.lang.String strokeDashArray = null;

   /**
    * Simple field ome.model.roi.Shape.strokeDashArray (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="strokeDashArray", updatable=true)
    public java.lang.String getStrokeDashArray() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeDashArray;
    }

    public void setStrokeDashArray(java.lang.String strokeDashArray) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeDashArray = (java.lang.String) strokeDashArray;
    }
    protected ome.model.units.Length strokeWidth = null;

 
   /**
    * Enum-mapped unit-based field ome.model.roi.Shape.strokeWidth (ome.model.units.Length)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="strokeWidth") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="strokeWidthUnit") )
    } )
    public ome.model.units.Length getStrokeWidth() {
        if (! _loaded ) errorIfUnloaded();
        return this.strokeWidth;
    }

    public void setStrokeWidth(ome.model.units.Length strokeWidth) {
        if (! _loaded ) errorIfUnloaded();
        this.strokeWidth = strokeWidth;
    }

    protected java.lang.String fontFamily = null;

   /**
    * Simple field ome.model.roi.Shape.fontFamily (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fontFamily", updatable=true)
    public java.lang.String getFontFamily() {
        if (! _loaded ) errorIfUnloaded();
        return this.fontFamily;
    }

    public void setFontFamily(java.lang.String fontFamily) {
        if (! _loaded ) errorIfUnloaded();
        this.fontFamily = (java.lang.String) fontFamily;
    }
    protected ome.model.units.Length fontSize = null;

 
   /**
    * Enum-mapped unit-based field ome.model.roi.Shape.fontSize (ome.model.units.Length)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="fontSize") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="fontSizeUnit") )
    } )
    public ome.model.units.Length getFontSize() {
        if (! _loaded ) errorIfUnloaded();
        return this.fontSize;
    }

    public void setFontSize(ome.model.units.Length fontSize) {
        if (! _loaded ) errorIfUnloaded();
        this.fontSize = fontSize;
    }

    protected java.lang.String fontStyle = null;

   /**
    * Simple field ome.model.roi.Shape.fontStyle (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="fontStyle", updatable=true)
    public java.lang.String getFontStyle() {
        if (! _loaded ) errorIfUnloaded();
        return this.fontStyle;
    }

    public void setFontStyle(java.lang.String fontStyle) {
        if (! _loaded ) errorIfUnloaded();
        this.fontStyle = (java.lang.String) fontStyle;
    }
    protected java.util.Set<ome.model.annotations.ShapeAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.ShapeAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "shape_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "shape_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "shape_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "shape_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.roi.Shape.annotationLinks (ome.model.annotations.ShapeAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.ShapeAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.ShapeAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.ShapeAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.ShapeAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.annotations.ShapeAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.ShapeAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.ShapeAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.ShapeAnnotationLink as well.
     */
    public void addShapeAnnotationLink(ome.model.annotations.ShapeAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addShapeAnnotationLink.
     */
    public void addShapeAnnotationLinkSet(java.util.Collection<ome.model.annotations.ShapeAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.ShapeAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.ShapeAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.ShapeAnnotationLink
     */
    public void removeShapeAnnotationLink(ome.model.annotations.ShapeAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeShapeAnnotationLink
     */
    public void removeShapeAnnotationLinkSet(java.util.Collection<ome.model.annotations.ShapeAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.ShapeAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.ShapeAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.ShapeAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.ShapeAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.ShapeAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.ShapeAnnotationLink link = new ome.model.annotations.ShapeAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addShapeAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.ShapeAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addShapeAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addShapeAnnotationLink (ome.model.annotations.ShapeAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.ShapeAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.ShapeAnnotationLink link = (ome.model.annotations.ShapeAnnotationLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.ShapeAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.ShapeAnnotationLink> findShapeAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.ShapeAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.ShapeAnnotationLink> result = new java.util.HashSet<ome.model.annotations.ShapeAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.ShapeAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.ShapeAnnotationLink> toRemove = findShapeAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.ShapeAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeShapeAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given ShapeAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkShape again <b>if loaded</b>.
     */
    public void removeShapeAnnotationLink (ome.model.annotations.ShapeAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.ShapeAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.ShapeAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.ShapeAnnotationLink link : list) {
            removeShapeAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Shape_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.ShapeAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Shape_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Shape_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Shape_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }


    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.theZ = (java.lang.Integer) __filter.filter(THEZ, this.theZ );
            this.theT = (java.lang.Integer) __filter.filter(THET, this.theT );
            this.theC = (java.lang.Integer) __filter.filter(THEC, this.theC );
            this.roi = (ome.model.roi.Roi) __filter.filter(ROI, this.roi );
            this.locked = (java.lang.Boolean) __filter.filter(LOCKED, this.locked );
            this.transform = (ome.model.roi.AffineTransform) __filter.filter(TRANSFORM, this.transform );
            this.fillColor = (java.lang.Integer) __filter.filter(FILLCOLOR, this.fillColor );
            this.fillRule = (java.lang.String) __filter.filter(FILLRULE, this.fillRule );
            this.strokeColor = (java.lang.Integer) __filter.filter(STROKECOLOR, this.strokeColor );
            this.strokeDashArray = (java.lang.String) __filter.filter(STROKEDASHARRAY, this.strokeDashArray );
            this.strokeWidth = (ome.model.units.Length) __filter.filter(STROKEWIDTH, this.strokeWidth );
            this.fontFamily = (java.lang.String) __filter.filter(FONTFAMILY, this.fontFamily );
            this.fontSize = (ome.model.units.Length) __filter.filter(FONTSIZE, this.fontSize );
            this.fontStyle = (java.lang.String) __filter.filter(FONTSTYLE, this.fontStyle );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.ShapeAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.roi.Shape.FIELDS;
    }

    public final static String THEZ = "ome.model.roi.Shape_theZ";
    public final static String THET = "ome.model.roi.Shape_theT";
    public final static String THEC = "ome.model.roi.Shape_theC";
    public final static String ROI = "ome.model.roi.Shape_roi";
    public final static String LOCKED = "ome.model.roi.Shape_locked";
    public final static String TRANSFORM = "ome.model.roi.Shape_transform";
    public final static String FILLCOLOR = "ome.model.roi.Shape_fillColor";
    public final static String FILLRULE = "ome.model.roi.Shape_fillRule";
    public final static String STROKECOLOR = "ome.model.roi.Shape_strokeColor";
    public final static String STROKEDASHARRAY = "ome.model.roi.Shape_strokeDashArray";
    public final static String STROKEWIDTH = "ome.model.roi.Shape_strokeWidth";
    public final static String FONTFAMILY = "ome.model.roi.Shape_fontFamily";
    public final static String FONTSIZE = "ome.model.roi.Shape_fontSize";
    public final static String FONTSTYLE = "ome.model.roi.Shape_fontStyle";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.roi.Shape_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.roi.Shape_annotationLinks";
    public final static String DETAILS = "ome.model.roi.Shape_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(THEZ);
       raw.add(THET);
       raw.add(THEC);
       raw.add(ROI);
       raw.add(LOCKED);
       raw.add(TRANSFORM);
       raw.add(FILLCOLOR);
       raw.add(FILLRULE);
       raw.add(STROKECOLOR);
       raw.add(STROKEDASHARRAY);
       raw.add(STROKEWIDTH);
       raw.add(FONTFAMILY);
       raw.add(FONTSIZE);
       raw.add(FONTSTYLE);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(THEZ)) {
            return getTheZ();
        } else if (field.equals(THET)) {
            return getTheT();
        } else if (field.equals(THEC)) {
            return getTheC();
        } else if (field.equals(ROI)) {
            return getRoi();
        } else if (field.equals(LOCKED)) {
            return getLocked();
        } else if (field.equals(TRANSFORM)) {
            return getTransform();
        } else if (field.equals(FILLCOLOR)) {
            return getFillColor();
        } else if (field.equals(FILLRULE)) {
            return getFillRule();
        } else if (field.equals(STROKECOLOR)) {
            return getStrokeColor();
        } else if (field.equals(STROKEDASHARRAY)) {
            return getStrokeDashArray();
        } else if (field.equals(STROKEWIDTH)) {
            return getStrokeWidth();
        } else if (field.equals(FONTFAMILY)) {
            return getFontFamily();
        } else if (field.equals(FONTSIZE)) {
            return getFontSize();
        } else if (field.equals(FONTSTYLE)) {
            return getFontStyle();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) {
            return getAnnotationLinks();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(THEZ)) {
            setTheZ((java.lang.Integer)value);
        } else if (field.equals(THET)) {
            setTheT((java.lang.Integer)value);
        } else if (field.equals(THEC)) {
            setTheC((java.lang.Integer)value);
        } else if (field.equals(ROI)) {
            setRoi((ome.model.roi.Roi)value);
        } else if (field.equals(LOCKED)) {
            setLocked((java.lang.Boolean)value);
        } else if (field.equals(TRANSFORM)) {
            setTransform((ome.model.roi.AffineTransform)value);
        } else if (field.equals(FILLCOLOR)) {
            setFillColor((java.lang.Integer)value);
        } else if (field.equals(FILLRULE)) {
            setFillRule((java.lang.String)value);
        } else if (field.equals(STROKECOLOR)) {
            setStrokeColor((java.lang.Integer)value);
        } else if (field.equals(STROKEDASHARRAY)) {
            setStrokeDashArray((java.lang.String)value);
        } else if (field.equals(STROKEWIDTH)) {
            setStrokeWidth((ome.model.units.Length)value);
        } else if (field.equals(FONTFAMILY)) {
            setFontFamily((java.lang.String)value);
        } else if (field.equals(FONTSIZE)) {
            setFontSize((ome.model.units.Length)value);
        } else if (field.equals(FONTSTYLE)) {
            setFontStyle((java.lang.String)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.ShapeAnnotationLink>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.theZ = null;
        this.theT = null;
        this.theC = null;
        this.roi = null;
        this.locked = null;
        this.transform = null;
        this.fillColor = null;
        this.fillRule = null;
        this.strokeColor = null;
        this.strokeDashArray = null;
        this.strokeWidth = null;
        this.fontFamily = null;
        this.fontSize = null;
        this.fontStyle = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKshape_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
