

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.screen;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="reagent_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="reagent_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="reagent_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="reagent_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="reagent_owner_filter_WELLLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="reagent_group_filter_WELLLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="reagent_event_filter_WELLLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="reagent_perms_filter_WELLLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="reagent_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="reagent_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="reagent_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="reagent_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="reagent_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="reagent_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="reagent_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="reagent_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "reagent", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_reagent",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_reagent"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Reagent
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "reagent_owner_filter";
    public final static String GROUP_FILTER = "reagent_group_filter";
    public final static String EVENT_FILTER = "reagent_event_filter";
    public final static String PERMS_FILTER = "reagent_perms_filter";

    public Reagent () {
        this(null, true);
    }

    protected Reagent (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Reagent (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Reagent(
ome.model.screen.Screen _screen    ) {
        this(null, true);
        setScreen(_screen);
    }

    public final static String ID = "ome.model.screen.Reagent_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_reagent") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.screen.Reagent_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.screen.Reagent.name (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected java.lang.String reagentIdentifier = null;

   /**
    * Simple field ome.model.screen.Reagent.reagentIdentifier (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="reagentIdentifier", updatable=true)
    public java.lang.String getReagentIdentifier() {
        if (! _loaded ) errorIfUnloaded();
        return this.reagentIdentifier;
    }

    public void setReagentIdentifier(java.lang.String reagentIdentifier) {
        if (! _loaded ) errorIfUnloaded();
        this.reagentIdentifier = (java.lang.String) reagentIdentifier;
    }
    protected ome.model.screen.Screen screen = null;

   /**
    * Many-to-one field ome.model.screen.Reagent.screen (ome.model.screen.Screen)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.screen.Screen.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="screen", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKreagent_screen_screen")
    public ome.model.screen.Screen getScreen() {
        if (! _loaded ) errorIfUnloaded();
        return this.screen;
    }

    public void setScreen(ome.model.screen.Screen screen) {
        if (! _loaded ) errorIfUnloaded();
        this.screen = screen;
    }
    protected java.util.Set<ome.model.screen.WellReagentLink> wellLinks = new java.util.HashSet<ome.model.screen.WellReagentLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_WELLLINKS = "reagent_owner_filter_WELLLINKS";
    public final static String GROUP_FILTER_WELLLINKS = "reagent_group_filter_WELLLINKS";
    public final static String EVENT_FILTER_WELLLINKS = "reagent_event_filter_WELLLINKS";
    public final static String PERMS_FILTER_WELLLINKS = "reagent_perms_filter_WELLLINKS";

   /**
    * returns wellLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Reagent.wellLinks (ome.model.screen.WellReagentLink)
    */
    @javax.persistence.OneToMany(mappedBy="child", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_WELLLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_WELLLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_WELLLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_WELLLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.screen.WellReagentLink> getWellLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.wellLinks;
    }

    /**
     * setter for wellLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setWellLinks(java.util.Set<ome.model.screen.WellReagentLink> wellLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.wellLinks = wellLinks;
    }
    /**
     * returns the size of wellLinks. If less than zero, the Set was null.
     */
    public int sizeOfWellLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.wellLinks == null ? -1 : this.wellLinks.size();
    }

    /**
     * should be used rather than accessing the wellLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfWellLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.screen.WellReagentLink> iterateWellLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWellLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.WellReagentLink>();
        }
        return getWellLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.screen.WellReagentLink> unmodifiableWellLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWellLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getWellLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.screen.WellReagentLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateWellLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectWellLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.WellReagentLink> it = iterateWellLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setWellLinks . Makes the necessary
     * call on ome.model.screen.WellReagentLink as well.
     */
    public void addWellReagentLink(ome.model.screen.WellReagentLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellLinks() == null) {
            throwNullCollectionException("WellLinks");
        }
        getWellLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setChild ( this );
         }
    }

    /**
     * use like addWellReagentLink.
     */
    public void addWellReagentLinkSet(java.util.Collection<ome.model.screen.WellReagentLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellLinks() == null) {
           throwNullCollectionException("WellLinks");
        }
        getWellLinks().addAll( targets );
        java.util.Iterator<ome.model.screen.WellReagentLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.WellReagentLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setChild ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.screen.WellReagentLink
     */
    public void removeWellReagentLink(ome.model.screen.WellReagentLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellLinks() == null) {
            throwNullCollectionException("WellLinks");
        }
        getWellLinks().remove( target );
            target.setChild ( null );
    }

    /**
     * use like removeWellReagentLink
     */
    public void removeWellReagentLinkSet(java.util.Collection<ome.model.screen.WellReagentLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getWellLinks() == null) {
            throwNullCollectionException("WellLinks");
        }
        getWellLinks().removeAll( targets );
        java.util.Iterator<ome.model.screen.WellReagentLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.WellReagentLink target = it.next();
                target.setChild ( null );
        }
    }




    /**
     * Adds a ome.model.screen.WellReagentLink to wellLinks . This entails changing our wellLinks Set,
     * creating a new ome.model.screen.WellReagentLink and calling linkWell on the ome.model.screen.Well.
     */
    public ome.model.screen.WellReagentLink linkWell (ome.model.screen.Well addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.screen.WellReagentLink link = new ome.model.screen.WellReagentLink();
        link.link( addition, this );

        // Add it to us and possibly the other side.
        addWellReagentLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.screen.WellReagentLink to wellLinks, allowing for recursion -- whether
     * or not addWellReagentLink will be called on the addition <b>if it is loaded</b>
     */
    public void addWellReagentLink (ome.model.screen.WellReagentLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getWellLinks() == null ) {
            throwNullCollectionException("WellLinks");
        }
        getWellLinks().add( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().addWellReagentLink( link, false );
        }
    }

    /**
     * provides an iterator over the child values of the wellLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedWellList()} instead.
     */
     public java.util.Iterator<ome.model.screen.Well> linkedWellIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getWellLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.Well>();
        }

        final java.util.Iterator<ome.model.screen.WellReagentLink> it = getWellLinks().iterator();
        return new java.util.Iterator<ome.model.screen.Well>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.screen.Well next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "wellLinks is null; no elements." );
                }
                ome.model.screen.WellReagentLink link = (ome.model.screen.WellReagentLink) it.next();
                return link.parent();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.screen.WellReagentLink which have the argument as their parent.
     */
    public java.util.Set<ome.model.screen.WellReagentLink> findWellReagentLink( ome.model.screen.Well target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.screen.WellReagentLink> it = iterateWellLinks();
        final java.util.Set<ome.model.screen.WellReagentLink> result = new java.util.HashSet<ome.model.screen.WellReagentLink>();
        while ( it.hasNext() ) {
            ome.model.screen.WellReagentLink link = it.next();
            if ( link.parent() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedWellIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.screen.Well> linkedWellList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.screen.Well> it = linkedWellIterator();
        java.util.List<ome.model.screen.Well> list = new java.util.ArrayList<ome.model.screen.Well>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.screen.Well while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedWell(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.Well> it = linkedWellIterator();
        while ( it.hasNext() ) {
            ome.model.screen.Well obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.screen.Well instances from this instance.
     */
    public void unlinkWell (ome.model.screen.Well removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.screen.WellReagentLink> toRemove = findWellReagentLink( removal );
        java.util.Iterator<ome.model.screen.WellReagentLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeWellReagentLink( it.next(), true );
        }
    }

    /**
     * removes the given WellReagentLink from wellLinks, allowing for recursion -- whether
     * or not the removal will call unlinkReagent again <b>if loaded</b>.
     */
    public void removeWellReagentLink (ome.model.screen.WellReagentLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getWellLinks() == null ) {
            throwNullCollectionException("WellLinks");
        }

        getWellLinks().remove( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().removeWellReagentLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearWellLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.screen.WellReagentLink> list = new java.util.ArrayList<ome.model.screen.WellReagentLink>( getWellLinks() );
        for (ome.model.screen.WellReagentLink link : list) {
            removeWellReagentLink( link, true );
        }
    }

    private java.util.Map<Long, Long> wellLinksCountPerOwner = null;

    protected void setWellLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.wellLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Reagent_wellLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.screen.WellReagentLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Reagent_wellLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Reagent_wellLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Reagent_id"))
    public java.util.Map<Long, Long> getWellLinksCountPerOwner() {
        return this.wellLinksCountPerOwner;
    }

    protected java.util.Set<ome.model.annotations.ReagentAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.ReagentAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "reagent_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "reagent_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "reagent_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "reagent_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Reagent.annotationLinks (ome.model.annotations.ReagentAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.ReagentAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.ReagentAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.ReagentAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.ReagentAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.annotations.ReagentAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.ReagentAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.ReagentAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.ReagentAnnotationLink as well.
     */
    public void addReagentAnnotationLink(ome.model.annotations.ReagentAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addReagentAnnotationLink.
     */
    public void addReagentAnnotationLinkSet(java.util.Collection<ome.model.annotations.ReagentAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.ReagentAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.ReagentAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.ReagentAnnotationLink
     */
    public void removeReagentAnnotationLink(ome.model.annotations.ReagentAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeReagentAnnotationLink
     */
    public void removeReagentAnnotationLinkSet(java.util.Collection<ome.model.annotations.ReagentAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.ReagentAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.ReagentAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.ReagentAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.ReagentAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.ReagentAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.ReagentAnnotationLink link = new ome.model.annotations.ReagentAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addReagentAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.ReagentAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addReagentAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addReagentAnnotationLink (ome.model.annotations.ReagentAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.ReagentAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.ReagentAnnotationLink link = (ome.model.annotations.ReagentAnnotationLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.ReagentAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.ReagentAnnotationLink> findReagentAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.ReagentAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.ReagentAnnotationLink> result = new java.util.HashSet<ome.model.annotations.ReagentAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.ReagentAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.ReagentAnnotationLink> toRemove = findReagentAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.ReagentAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeReagentAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given ReagentAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkReagent again <b>if loaded</b>.
     */
    public void removeReagentAnnotationLink (ome.model.annotations.ReagentAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.ReagentAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.ReagentAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.ReagentAnnotationLink link : list) {
            removeReagentAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Reagent_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.ReagentAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Reagent_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Reagent_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Reagent_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected java.lang.String description = null;

   /**
    * Simple field ome.model.screen.Reagent.description (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="description", updatable=true)
    public java.lang.String getDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.description;
    }

    public void setDescription(java.lang.String description) {
        if (! _loaded ) errorIfUnloaded();
        this.description = (java.lang.String) description;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.screen.Reagent newInstance()
    {
        return new ome.model.screen.Reagent();
    }

    public ome.model.screen.Reagent proxy() {
        return new ome.model.screen.Reagent(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.reagentIdentifier = (java.lang.String) __filter.filter(REAGENTIDENTIFIER, this.reagentIdentifier );
            this.screen = (ome.model.screen.Screen) __filter.filter(SCREEN, this.screen );
            this.wellLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(WELLLINKSCOUNTPEROWNER, this.wellLinksCountPerOwner );
            this.wellLinks = (java.util.Set<ome.model.screen.WellReagentLink>) __filter.filter(WELLLINKS, this.wellLinks );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.ReagentAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.description = (java.lang.String) __filter.filter(DESCRIPTION, this.description );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.screen.Reagent.FIELDS;
    }

    public final static String NAME = "ome.model.screen.Reagent_name";
    public final static String REAGENTIDENTIFIER = "ome.model.screen.Reagent_reagentIdentifier";
    public final static String SCREEN = "ome.model.screen.Reagent_screen";
    public final static String WELLLINKSCOUNTPEROWNER = "ome.model.screen.Reagent_wellLinksCountPerOwner";
    public final static String WELLLINKS = "ome.model.screen.Reagent_wellLinks";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.screen.Reagent_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.screen.Reagent_annotationLinks";
    public final static String DESCRIPTION = "ome.model.screen.Reagent_description";
    public final static String DETAILS = "ome.model.screen.Reagent_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(NAME);
       raw.add(REAGENTIDENTIFIER);
       raw.add(SCREEN);
       raw.add(WELLLINKSCOUNTPEROWNER);
       raw.add(WELLLINKS);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(DESCRIPTION);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(NAME)) {
            return getName();
        } else if (field.equals(REAGENTIDENTIFIER)) {
            return getReagentIdentifier();
        } else if (field.equals(SCREEN)) {
            return getScreen();
        } else if (field.equals(WELLLINKSCOUNTPEROWNER)) {
            return getWellLinksCountPerOwner();
        } else if (field.equals(WELLLINKS)) {
            return getWellLinks();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) {
            return getAnnotationLinks();
        } else if (field.equals(DESCRIPTION)) {
            return getDescription();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(REAGENTIDENTIFIER)) {
            setReagentIdentifier((java.lang.String)value);
        } else if (field.equals(SCREEN)) {
            setScreen((ome.model.screen.Screen)value);
        } else if (field.equals(WELLLINKSCOUNTPEROWNER)) {
            setWellLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(WELLLINKS)) {
            setWellLinks((java.util.Set<ome.model.screen.WellReagentLink>)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.ReagentAnnotationLink>)value);
        } else if (field.equals(DESCRIPTION)) {
            setDescription((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.name = null;
        this.reagentIdentifier = null;
        this.screen = null;
        this.wellLinksCountPerOwner = null;
        this.wellLinks = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.description = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKreagent_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKreagent_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKreagent_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKreagent_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKreagent_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
