

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.screen;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="screen_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="screen_owner_filter_PLATELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_group_filter_PLATELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_event_filter_PLATELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_perms_filter_PLATELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="screen_owner_filter_REAGENTS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_group_filter_REAGENTS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_event_filter_REAGENTS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_perms_filter_REAGENTS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="screen_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="screen_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="screen_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="screen_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="screen_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="screen_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "screen", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_screen",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_screen"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Screen
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "screen_owner_filter";
    public final static String GROUP_FILTER = "screen_group_filter";
    public final static String EVENT_FILTER = "screen_event_filter";
    public final static String PERMS_FILTER = "screen_perms_filter";

    public Screen () {
        this(null, true);
    }

    protected Screen (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Screen (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Screen(
java.lang.String _name    ) {
        this(null, true);
        setName(_name);
    }

    public final static String ID = "ome.model.screen.Screen_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_screen") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.screen.Screen_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String type = null;

   /**
    * Simple field ome.model.screen.Screen.type (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="type", updatable=true)
    public java.lang.String getType() {
        if (! _loaded ) errorIfUnloaded();
        return this.type;
    }

    public void setType(java.lang.String type) {
        if (! _loaded ) errorIfUnloaded();
        this.type = (java.lang.String) type;
    }
    protected java.lang.String protocolIdentifier = null;

   /**
    * Simple field ome.model.screen.Screen.protocolIdentifier (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="protocolIdentifier", updatable=true)
    public java.lang.String getProtocolIdentifier() {
        if (! _loaded ) errorIfUnloaded();
        return this.protocolIdentifier;
    }

    public void setProtocolIdentifier(java.lang.String protocolIdentifier) {
        if (! _loaded ) errorIfUnloaded();
        this.protocolIdentifier = (java.lang.String) protocolIdentifier;
    }
    protected java.lang.String protocolDescription = null;

   /**
    * Simple field ome.model.screen.Screen.protocolDescription (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="protocolDescription", updatable=true)
    public java.lang.String getProtocolDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.protocolDescription;
    }

    public void setProtocolDescription(java.lang.String protocolDescription) {
        if (! _loaded ) errorIfUnloaded();
        this.protocolDescription = (java.lang.String) protocolDescription;
    }
    protected java.lang.String reagentSetIdentifier = null;

   /**
    * Simple field ome.model.screen.Screen.reagentSetIdentifier (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="reagentSetIdentifier", updatable=true)
    public java.lang.String getReagentSetIdentifier() {
        if (! _loaded ) errorIfUnloaded();
        return this.reagentSetIdentifier;
    }

    public void setReagentSetIdentifier(java.lang.String reagentSetIdentifier) {
        if (! _loaded ) errorIfUnloaded();
        this.reagentSetIdentifier = (java.lang.String) reagentSetIdentifier;
    }
    protected java.lang.String reagentSetDescription = null;

   /**
    * Simple field ome.model.screen.Screen.reagentSetDescription (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="reagentSetDescription", updatable=true)
    public java.lang.String getReagentSetDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.reagentSetDescription;
    }

    public void setReagentSetDescription(java.lang.String reagentSetDescription) {
        if (! _loaded ) errorIfUnloaded();
        this.reagentSetDescription = (java.lang.String) reagentSetDescription;
    }
    protected java.util.Set<ome.model.screen.ScreenPlateLink> plateLinks = new java.util.HashSet<ome.model.screen.ScreenPlateLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_PLATELINKS = "screen_owner_filter_PLATELINKS";
    public final static String GROUP_FILTER_PLATELINKS = "screen_group_filter_PLATELINKS";
    public final static String EVENT_FILTER_PLATELINKS = "screen_event_filter_PLATELINKS";
    public final static String PERMS_FILTER_PLATELINKS = "screen_perms_filter_PLATELINKS";

   /**
    * returns plateLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Screen.plateLinks (ome.model.screen.ScreenPlateLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_PLATELINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_PLATELINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_PLATELINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_PLATELINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.screen.ScreenPlateLink> getPlateLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.plateLinks;
    }

    /**
     * setter for plateLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setPlateLinks(java.util.Set<ome.model.screen.ScreenPlateLink> plateLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.plateLinks = plateLinks;
    }
    /**
     * returns the size of plateLinks. If less than zero, the Set was null.
     */
    public int sizeOfPlateLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.plateLinks == null ? -1 : this.plateLinks.size();
    }

    /**
     * should be used rather than accessing the plateLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfPlateLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.screen.ScreenPlateLink> iteratePlateLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPlateLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.ScreenPlateLink>();
        }
        return getPlateLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.screen.ScreenPlateLink> unmodifiablePlateLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPlateLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getPlateLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.screen.ScreenPlateLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iteratePlateLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectPlateLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.ScreenPlateLink> it = iteratePlateLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setPlateLinks . Makes the necessary
     * call on ome.model.screen.ScreenPlateLink as well.
     */
    public void addScreenPlateLink(ome.model.screen.ScreenPlateLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getPlateLinks() == null) {
            throwNullCollectionException("PlateLinks");
        }
        getPlateLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addScreenPlateLink.
     */
    public void addScreenPlateLinkSet(java.util.Collection<ome.model.screen.ScreenPlateLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getPlateLinks() == null) {
           throwNullCollectionException("PlateLinks");
        }
        getPlateLinks().addAll( targets );
        java.util.Iterator<ome.model.screen.ScreenPlateLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.ScreenPlateLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.screen.ScreenPlateLink
     */
    public void removeScreenPlateLink(ome.model.screen.ScreenPlateLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getPlateLinks() == null) {
            throwNullCollectionException("PlateLinks");
        }
        getPlateLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeScreenPlateLink
     */
    public void removeScreenPlateLinkSet(java.util.Collection<ome.model.screen.ScreenPlateLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getPlateLinks() == null) {
            throwNullCollectionException("PlateLinks");
        }
        getPlateLinks().removeAll( targets );
        java.util.Iterator<ome.model.screen.ScreenPlateLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.ScreenPlateLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.screen.ScreenPlateLink to plateLinks . This entails changing our plateLinks Set,
     * creating a new ome.model.screen.ScreenPlateLink and calling linkPlate on the ome.model.screen.Plate.
     */
    public ome.model.screen.ScreenPlateLink linkPlate (ome.model.screen.Plate addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.screen.ScreenPlateLink link = new ome.model.screen.ScreenPlateLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addScreenPlateLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.screen.ScreenPlateLink to plateLinks, allowing for recursion -- whether
     * or not addScreenPlateLink will be called on the addition <b>if it is loaded</b>
     */
    public void addScreenPlateLink (ome.model.screen.ScreenPlateLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getPlateLinks() == null ) {
            throwNullCollectionException("PlateLinks");
        }
        getPlateLinks().add( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().addScreenPlateLink( link, false );
        }
    }

    /**
     * provides an iterator over the parent values of the plateLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedPlateList()} instead.
     */
     public java.util.Iterator<ome.model.screen.Plate> linkedPlateIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPlateLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.Plate>();
        }

        final java.util.Iterator<ome.model.screen.ScreenPlateLink> it = getPlateLinks().iterator();
        return new java.util.Iterator<ome.model.screen.Plate>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.screen.Plate next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "plateLinks is null; no elements." );
                }
                ome.model.screen.ScreenPlateLink link = (ome.model.screen.ScreenPlateLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.screen.ScreenPlateLink which have the argument as their child.
     */
    public java.util.Set<ome.model.screen.ScreenPlateLink> findScreenPlateLink( ome.model.screen.Plate target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.screen.ScreenPlateLink> it = iteratePlateLinks();
        final java.util.Set<ome.model.screen.ScreenPlateLink> result = new java.util.HashSet<ome.model.screen.ScreenPlateLink>();
        while ( it.hasNext() ) {
            ome.model.screen.ScreenPlateLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedPlateIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.screen.Plate> linkedPlateList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.screen.Plate> it = linkedPlateIterator();
        java.util.List<ome.model.screen.Plate> list = new java.util.ArrayList<ome.model.screen.Plate>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.screen.Plate while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedPlate(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.Plate> it = linkedPlateIterator();
        while ( it.hasNext() ) {
            ome.model.screen.Plate obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.screen.Plate instances from this instance.
     */
    public void unlinkPlate (ome.model.screen.Plate removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.screen.ScreenPlateLink> toRemove = findScreenPlateLink( removal );
        java.util.Iterator<ome.model.screen.ScreenPlateLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeScreenPlateLink( it.next(), true );
        }
    }

    /**
     * removes the given ScreenPlateLink from plateLinks, allowing for recursion -- whether
     * or not the removal will call unlinkScreen again <b>if loaded</b>.
     */
    public void removeScreenPlateLink (ome.model.screen.ScreenPlateLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getPlateLinks() == null ) {
            throwNullCollectionException("PlateLinks");
        }

        getPlateLinks().remove( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().removeScreenPlateLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearPlateLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.screen.ScreenPlateLink> list = new java.util.ArrayList<ome.model.screen.ScreenPlateLink>( getPlateLinks() );
        for (ome.model.screen.ScreenPlateLink link : list) {
            removeScreenPlateLink( link, true );
        }
    }

    private java.util.Map<Long, Long> plateLinksCountPerOwner = null;

    protected void setPlateLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.plateLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Screen_plateLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.screen.ScreenPlateLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Screen_plateLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Screen_plateLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Screen_id"))
    public java.util.Map<Long, Long> getPlateLinksCountPerOwner() {
        return this.plateLinksCountPerOwner;
    }

    protected java.util.Set<ome.model.screen.Reagent> reagents = new java.util.HashSet<ome.model.screen.Reagent>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_REAGENTS = "screen_owner_filter_REAGENTS";
    public final static String GROUP_FILTER_REAGENTS = "screen_group_filter_REAGENTS";
    public final static String EVENT_FILTER_REAGENTS = "screen_event_filter_REAGENTS";
    public final static String PERMS_FILTER_REAGENTS = "screen_perms_filter_REAGENTS";

   /**
    * returns reagents . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Screen.reagents (ome.model.screen.Reagent)
    */
    @javax.persistence.OneToMany(mappedBy="screen", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_REAGENTS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_REAGENTS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_REAGENTS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_REAGENTS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.screen.Reagent> getReagents() {
        if (! _loaded ) errorIfUnloaded();
        return this.reagents;
    }

    /**
     * setter for reagents should be avoided. Does not fulfill normal semantics.
     */
    protected void setReagents(java.util.Set<ome.model.screen.Reagent> reagents) {
        if (! _loaded ) errorIfUnloaded();
        this.reagents = reagents;
    }
    /**
     * returns the size of reagents. If less than zero, the Set was null.
     */
    public int sizeOfReagents() {
        if (! _loaded ) errorIfUnloaded();
        return this.reagents == null ? -1 : this.reagents.size();
    }

    /**
     * should be used rather than accessing the reagents set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfReagents()} is less than zero.
     */
    public java.util.Iterator<ome.model.screen.Reagent> iterateReagents() {
        if (! _loaded ) errorIfUnloaded();
        if ( getReagents() == null ) {
            return new ome.util.EmptyIterator<ome.model.screen.Reagent>();
        }
        return getReagents().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.screen.Reagent> unmodifiableReagents() {
        if (! _loaded ) errorIfUnloaded();
        if ( getReagents() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getReagents() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.screen.Reagent while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateReagents} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectReagents(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.screen.Reagent> it = iterateReagents();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setReagents . Makes the necessary
     * call on ome.model.screen.Reagent as well.
     */
    public void addReagent(ome.model.screen.Reagent target) {
        if (! _loaded ) errorIfUnloaded();
        if (getReagents() == null) {
            throwNullCollectionException("Reagents");
        }
        getReagents().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setScreen ( this );
         }
    }

    /**
     * use like addReagent.
     */
    public void addReagentSet(java.util.Collection<ome.model.screen.Reagent> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getReagents() == null) {
           throwNullCollectionException("Reagents");
        }
        getReagents().addAll( targets );
        java.util.Iterator<ome.model.screen.Reagent> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.Reagent target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setScreen ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.screen.Reagent
     */
    public void removeReagent(ome.model.screen.Reagent target) {
        if (! _loaded ) errorIfUnloaded();
        if (getReagents() == null) {
            throwNullCollectionException("Reagents");
        }
        getReagents().remove( target );
            target.setScreen ( null );
    }

    /**
     * use like removeReagent
     */
    public void removeReagentSet(java.util.Collection<ome.model.screen.Reagent> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getReagents() == null) {
            throwNullCollectionException("Reagents");
        }
        getReagents().removeAll( targets );
        java.util.Iterator<ome.model.screen.Reagent> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.screen.Reagent target = it.next();
                target.setScreen ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearReagents() {
        if (! _loaded ) errorIfUnloaded();
        if (getReagents() == null) {
            throwNullCollectionException("Reagents");
        }
        getReagents().clear();
        java.util.Iterator<ome.model.screen.Reagent> it = iterateReagents();
        while (it.hasNext()) {
            ome.model.screen.Reagent target = it.next();
            target.setScreen ( null );
        }
    }


    protected java.util.Set<ome.model.annotations.ScreenAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.ScreenAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "screen_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "screen_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "screen_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "screen_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.screen.Screen.annotationLinks (ome.model.annotations.ScreenAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.ScreenAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.ScreenAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.ScreenAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.ScreenAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.annotations.ScreenAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.ScreenAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.ScreenAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.ScreenAnnotationLink as well.
     */
    public void addScreenAnnotationLink(ome.model.annotations.ScreenAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addScreenAnnotationLink.
     */
    public void addScreenAnnotationLinkSet(java.util.Collection<ome.model.annotations.ScreenAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.ScreenAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.ScreenAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.ScreenAnnotationLink
     */
    public void removeScreenAnnotationLink(ome.model.annotations.ScreenAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeScreenAnnotationLink
     */
    public void removeScreenAnnotationLinkSet(java.util.Collection<ome.model.annotations.ScreenAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.ScreenAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.ScreenAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.ScreenAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.ScreenAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.ScreenAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.ScreenAnnotationLink link = new ome.model.annotations.ScreenAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addScreenAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.ScreenAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addScreenAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addScreenAnnotationLink (ome.model.annotations.ScreenAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.ScreenAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.ScreenAnnotationLink link = (ome.model.annotations.ScreenAnnotationLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.ScreenAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.ScreenAnnotationLink> findScreenAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.ScreenAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.ScreenAnnotationLink> result = new java.util.HashSet<ome.model.annotations.ScreenAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.ScreenAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.ScreenAnnotationLink> toRemove = findScreenAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.ScreenAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeScreenAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given ScreenAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkScreen again <b>if loaded</b>.
     */
    public void removeScreenAnnotationLink (ome.model.annotations.ScreenAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.ScreenAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.ScreenAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.ScreenAnnotationLink link : list) {
            removeScreenAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Screen_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.ScreenAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Screen_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Screen_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Screen_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.screen.Screen.name (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected java.lang.String description = null;

   /**
    * Simple field ome.model.screen.Screen.description (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="description", updatable=true)
    public java.lang.String getDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.description;
    }

    public void setDescription(java.lang.String description) {
        if (! _loaded ) errorIfUnloaded();
        this.description = (java.lang.String) description;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.screen.Screen newInstance()
    {
        return new ome.model.screen.Screen();
    }

    public ome.model.screen.Screen proxy() {
        return new ome.model.screen.Screen(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.type = (java.lang.String) __filter.filter(TYPE, this.type );
            this.protocolIdentifier = (java.lang.String) __filter.filter(PROTOCOLIDENTIFIER, this.protocolIdentifier );
            this.protocolDescription = (java.lang.String) __filter.filter(PROTOCOLDESCRIPTION, this.protocolDescription );
            this.reagentSetIdentifier = (java.lang.String) __filter.filter(REAGENTSETIDENTIFIER, this.reagentSetIdentifier );
            this.reagentSetDescription = (java.lang.String) __filter.filter(REAGENTSETDESCRIPTION, this.reagentSetDescription );
            this.plateLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(PLATELINKSCOUNTPEROWNER, this.plateLinksCountPerOwner );
            this.plateLinks = (java.util.Set<ome.model.screen.ScreenPlateLink>) __filter.filter(PLATELINKS, this.plateLinks );
            this.reagents = (java.util.Set<ome.model.screen.Reagent>) __filter.filter(REAGENTS, this.reagents );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.ScreenAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.description = (java.lang.String) __filter.filter(DESCRIPTION, this.description );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.screen.Screen.FIELDS;
    }

    public final static String TYPE = "ome.model.screen.Screen_type";
    public final static String PROTOCOLIDENTIFIER = "ome.model.screen.Screen_protocolIdentifier";
    public final static String PROTOCOLDESCRIPTION = "ome.model.screen.Screen_protocolDescription";
    public final static String REAGENTSETIDENTIFIER = "ome.model.screen.Screen_reagentSetIdentifier";
    public final static String REAGENTSETDESCRIPTION = "ome.model.screen.Screen_reagentSetDescription";
    public final static String PLATELINKSCOUNTPEROWNER = "ome.model.screen.Screen_plateLinksCountPerOwner";
    public final static String PLATELINKS = "ome.model.screen.Screen_plateLinks";
    public final static String REAGENTS = "ome.model.screen.Screen_reagents";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.screen.Screen_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.screen.Screen_annotationLinks";
    public final static String NAME = "ome.model.screen.Screen_name";
    public final static String DESCRIPTION = "ome.model.screen.Screen_description";
    public final static String DETAILS = "ome.model.screen.Screen_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(TYPE);
       raw.add(PROTOCOLIDENTIFIER);
       raw.add(PROTOCOLDESCRIPTION);
       raw.add(REAGENTSETIDENTIFIER);
       raw.add(REAGENTSETDESCRIPTION);
       raw.add(PLATELINKSCOUNTPEROWNER);
       raw.add(PLATELINKS);
       raw.add(REAGENTS);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(NAME);
       raw.add(DESCRIPTION);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(TYPE)) {
            return getType();
        } else if (field.equals(PROTOCOLIDENTIFIER)) {
            return getProtocolIdentifier();
        } else if (field.equals(PROTOCOLDESCRIPTION)) {
            return getProtocolDescription();
        } else if (field.equals(REAGENTSETIDENTIFIER)) {
            return getReagentSetIdentifier();
        } else if (field.equals(REAGENTSETDESCRIPTION)) {
            return getReagentSetDescription();
        } else if (field.equals(PLATELINKSCOUNTPEROWNER)) {
            return getPlateLinksCountPerOwner();
        } else if (field.equals(PLATELINKS)) {
            return getPlateLinks();
        } else if (field.equals(REAGENTS)) {
            return getReagents();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) {
            return getAnnotationLinks();
        } else if (field.equals(NAME)) {
            return getName();
        } else if (field.equals(DESCRIPTION)) {
            return getDescription();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(TYPE)) {
            setType((java.lang.String)value);
        } else if (field.equals(PROTOCOLIDENTIFIER)) {
            setProtocolIdentifier((java.lang.String)value);
        } else if (field.equals(PROTOCOLDESCRIPTION)) {
            setProtocolDescription((java.lang.String)value);
        } else if (field.equals(REAGENTSETIDENTIFIER)) {
            setReagentSetIdentifier((java.lang.String)value);
        } else if (field.equals(REAGENTSETDESCRIPTION)) {
            setReagentSetDescription((java.lang.String)value);
        } else if (field.equals(PLATELINKSCOUNTPEROWNER)) {
            setPlateLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(PLATELINKS)) {
            setPlateLinks((java.util.Set<ome.model.screen.ScreenPlateLink>)value);
        } else if (field.equals(REAGENTS)) {
            setReagents((java.util.Set<ome.model.screen.Reagent>)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.ScreenAnnotationLink>)value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(DESCRIPTION)) {
            setDescription((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.type = null;
        this.protocolIdentifier = null;
        this.protocolDescription = null;
        this.reagentSetIdentifier = null;
        this.reagentSetDescription = null;
        this.plateLinksCountPerOwner = null;
        this.plateLinks = null;
        this.reagents = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.name = null;
        this.description = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKscreen_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKscreen_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKscreen_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKscreen_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKscreen_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
